#include "globals.h"
#include "dev.h"
#include "config.h"

#include "game.h"
#include "player.h"
#include "display.h"
#include "level.h"
#include "font.h"
#include "misc.h"
#include "encounter.h"
#include "inn.h"
#include "smithy.h"
#include "tavern.h"
#include "bank.h"
#include "shop.h"
#include "items.h"
#include "audio.h"

using namespace std;

void startGame();

bool newGame = true;
bool programRunning = true;


int main()
{
    string key;

    if (!loadConfig()) return 0; // load screen resolution from arx.ini
    //FreeConsole(); // Hides the console window - make ARX.ini option
	setDeveloperFlags();
	createGameWindow();
	//setScreenValues();
    dispInit();
	InitFont();
	loadLogoImage();

	initSaveGameDescriptions();

	while (programRunning)
	{
		clearDisplay();
		displayMainMenu();
		updateDisplay();

		key = getSingleKey();

		if ( key=="1" )
		{
            createNewCharacter(CITY);
            startGame();
		}

		if ( key=="2" )
		{
            createNewCharacter(DUNGEON);
            startGame();
		}

		if ( key=="3" )
		{
			int loadgameMenu = 255; // high level menu
			while (loadgameMenu < 256)
			{
				while (loadgameMenu == 255) // main menu
				{
					clearDisplay();
					displayLoadGame();
					drawText(12,0,"Load a character");
					updateDisplay();

					key = getSingleKey();
					if ( key=="0" ) { loadgameMenu = 0; }
					if ( key=="1" ) { loadgameMenu = 1; }
					if ( key=="2" ) { loadgameMenu = 2; }
					if ( key=="3" ) { loadgameMenu = 3; }
					if ( key=="4" ) { loadgameMenu = 4; }
					if ( key=="5" ) { loadgameMenu = 5; }
					if ( key=="6" ) { loadgameMenu = 6; }
					if ( key=="7" ) { loadgameMenu = 7; }
					if ( key=="8" ) { loadgameMenu = 8; }
					if ( key=="9" ) { loadgameMenu = 9; }
					if ( key=="ESC" ) { loadgameMenu = 256; }
				}
				while (loadgameMenu < 10) // attempt to load a save game
				{
					if (loadCharacter(loadgameMenu)) { newGame = false; startGame(); }
					loadgameMenu = 256; // to break from loop
				}
			}
		}


		if ( key=="4" ) { displayAcknowledgements(); }


		if ( key=="5" )
		{
			if (graphicMode==0) { graphicMode=1; dispInit();}
			else
			if (graphicMode==1) { graphicMode=2; createGameWindow();dispInit();}
			else
			if (graphicMode==2) { graphicMode=0; createGameWindow();dispInit();}

		}

		if ( key=="6" )
		{
			if (plyr.musicStyle==0) { plyr.musicStyle=1;}
			else { plyr.musicStyle=0; }
		}

		if ( key=="7" )
		{
			if (plyr.fontStyle==0) { plyr.fontStyle=1;}
			else { plyr.fontStyle=0;}
			InitFont();
		}

		if ( key=="0" ) { programRunning = false; }
		if ( key=="QUIT" ) { programRunning = false; }
	}

	return EXIT_SUCCESS;
}


void startGame()
{

    displayLoading(); // display loading message on screen
	loadResources(); // load up images for textures and backdrops once the graphic style has been selected
	initEncounterThemes();
	initMaps();
	loadMapData(plyr.map);
	loadDescriptions(plyr.map);
	loadZoneData(plyr.map);
	loadMessages(plyr.map);
	loadEncounters();
	loadWeapons(); //temp
	checkBackgroundTime(); // determine background graphics based on time of day

	checkDailyInnJobOpenings();
	checkDailyTavernJobOpenings();
	checkDailybankJobOpenings();

initialiseNewGame();

    gameLoop(); // Enter the main game loop
}


