
#include <SFML/Graphics.hpp>
#include <SFML/Audio.hpp>

#include <string>
#include <iostream>
#include <sstream>

#include "player.h"
#include "font.h"
#include "display.h"
#include "explore.h"
#include "misc.h"
#include "dungeonGuild.h"

//extern string mess[25];
//extern string room_descriptions[203];
//extern Mapcell levelmap[4096];
extern Player plyr;
//extern Teleport teleports[32];
extern sf::RenderWindow App;
sf::Music dungeonGuildMusic1;

struct dungeonGuild
{
       string name;
       int x;
       int y;
       int dungeon_level;
       int type;
       int enemy_guild;
};



dungeonGuild dungeonGuilds[8] =
{
    {"Guild of Chaos",50,4,2,1,2},
    {"Guild of Order",58,14,2,2,1},
    {"Wizards of Law Guild",62,14,2,2,4},
    {"Thieves' Guild",44,30,2,1,3},
    {"Dark Wizards Guild",33,42,2,1,6},
    {"Light Wizards Guild",2,59,2,2,5},
	{"Mercenaries' Guild",8,19,3,1,5},
	{"Paladins' Guild",2,5,3,2,5}
};


inline std::string concat( int n, const char* str )
{
std::ostringstream ss;
ss << n;
ss << str;
return ss.str();
}



void shopDungeonGuild()
{
	int guildNo = getDungeonGuildNo();
	if (dungeonGuilds[guildNo].type==1) { dungeonGuildMusic1.openFromFile("data/audio/evilGuild.ogg"); }
	else { dungeonGuildMusic1.openFromFile("data/audio/goodGuild.ogg"); }
	bool musicPlaying = false;
	int guildMenu = 1; // high level menu
	string str,key;
	plyr.status = 2; // shopping

	while (guildMenu > 0)
	{
		while (guildMenu == 1) // main menu
		{
			if (dungeonGuilds[guildNo].type==1) { clearShopDisplay(); } else { clearShopDisplay(); }
			str = "Welcome to the " + dungeonGuilds[guildNo].name + ".";
			cyText (1, str);
			bText (6,3, "(1) Apply for Guild membership.");
			bText (6,5, "(0) Leave.");
			updateDisplay();
			if (!musicPlaying) { dungeonGuildMusic1.play(); musicPlaying = true; }


			key = getSingleKey();
			if ( key=="0" ) { guildMenu = 0; }
			if ( key=="1" ) { guildMenu = 2; }

		}



		while (guildMenu == 2) // Join guild menu
		{
			if (dungeonGuilds[guildNo].type==1) { clearShopDisplay(); } else { clearShopDisplay(); }
			cyText (2,"I am deeply sorry but you have not");
			cyText (4,"the experience to join our guild yet.");
			cyText (9,"( Press a key )");
			updateDisplay();

			key = getSingleKey();
			if ( key!="" ) { guildMenu = 0; }
		}


	}
	dungeonGuildMusic1.stop();
	leaveShop();
}



int getDungeonGuildNo()
{
	int guild_no;
	for (int i=0 ; i<=7 ; i++) // Max number of guild objects
		{
			if ((dungeonGuilds[i].x == plyr.x) && (dungeonGuilds[i].y == plyr.y))
			{
				guild_no = i; // The number of the guild you have entered
			}
	   }
	return guild_no;
}
