//#include <SFML/Graphics.hpp>
//#include <SFML/OpenGL.hpp>
#include <SFML/Audio.hpp>

#include <fstream>
#include <iostream>
#include <sstream>
#include <string>

#include "player.h"
#include "font.h"
#include "display.h"
#include "level.h"
#include "game.h"
#include "misc.h"
#include "encounter.h"
#include "items.h"
#include "automap.h"
#include "audio.h"

const int noOfEncounters = 87;
const int noOfWeapons = 110;

void awardExperience(int opponentNo);
void text(string str);

encRecord wellLitEncTable[10]=
{
	{30,	GUARD,		1},
	{30,	THIEF,		1},
	{30,	GIANT_RAT,	1},
	{30,	NOBLEMAN,	1},
	{30,	PAUPER,		1},
	{30,	HEALER,		1},
	{20,	KNIGHT,		1},
	{20,	NOBLEWOMAN,	1},
	{20,	SLIME,		1},
	{15,	ADVENTURER,	1}
};


encRecord nightEncTable[48]=
{
	{19,	GHOST,	    1},
	{17,	MUGGER,	    1},
	{17,	GIANT_RAT,	1},
	{17,	SKELETON,	1},
	{16,	ZOMBIE,	    1},
	{15,	GREMLIN,	1},
	{12,	MOLD,	    1}, // was brown mold
	{10,	MASTER_THIEF,	1},
	{9,		CUTTHROAT,	1},
	{9,		GIANT,	    1},
	{8,		SLIME,	    1}, // was black slime
	{7,		GIANT_WOLF,	1},
	{7,		CHAMPION,	1},
	{7,		IMP,	    1},
	{7,		GHOUL,	    1},
	{6,		FIGHTER,	1},
	{5,		SWORDSMAN,	1},
	{5,		WARRIOR,	1},
	{4,		GNOLL,	    1},
	{4,		THIEF,	    1},
	{3,		SMALL_GREEN_DRAGON,	1},
	{3,		GLADIATOR,	1},
	{3,		GOBLIN,	    1},
	{3,		HOBBIT,	    1},
	{3,		ORC,	    1},
	{3,		DWARF,	    1},
	{2,		WRAITH,	    1},
	{2,		APPRENTICE,	1},
	{2,		KNIGHT,	    1},
	{2,		ACOLYTE,	1},
	{2,		TROLL,	    1},
	{2,		ARCHMAGE,	1},
	{2,		ROBBER,	    1},
	{2,		GUARD,	    1},
	{2,		BRIGAND,	1},
	{1,		NOVICE,	    1},
	{1,		NIGHTSTALKER,	1},
	{1,		SPECTRE,	1},
	{1,		KNIGHT,	    1},
	{1,		WIZARD,	    1},
	{1,		COMMONER,	1},
	{1,		MERCHANT,	1},
	{1,		COURIER,	1},
	{1,		WEAPONMASTER,	1},
	{1,		NOBLEMAN,	1},
	{1,		PAUPER,	    1},
	{1,		MAGE,	    1},
	{1,		ASSASSIN,	1}
};

// Probability, Type, Quantity
encRecord dayEncTable[29] =
{
	{41,	GUARD,	1},
	{19,	COMMONER,	1},
	{19,	MERCHANT,	1},
	{18,	APPRENTICE,	1},
	{18,	ACOLYTE,	1},
	{17,	ARCHMAGE,	1},
	{16,	COURIER,	1},
	{12,	KNIGHT,	1},
	{10,	NOVICE,	1},
	{10,	MUGGER,	1},
	{8,		WIZARD,	1},
	{8,		CHAMPION,	1},
	{7,		FIGHTER,	1},
	{6,		SWORDSMAN,	1},
	{6,		MASTER_THIEF,	1},
	{6,		WARRIOR,	1},
	{5,		THIEF,	1},
	{5,		NOBLEMAN,	1},
	{4,		PAUPER,	1},
	{4,		GLADIATOR,	1},
	{3,		GUARD,	1},
	{3,		KNIGHT,	1},
	{3,		THIEF,	1},
	{1,		ROBBER,	1},
	{1,		MAGE,	1},
	{1,		ASSASSIN,	1},
	{1,		BRIGAND,	1},
	{1,		WEAPONMASTER,	1},
	{2,     NOBLEWOMAN,     1}
};




int maxMonsters = 86; // City and Dungeon monsters combined

monster Opponents[8]; // max 8 monsters against you
monster Monsters[noOfEncounters]; // City and Dungeon monsters combined
monster opponent;
weapon Weapons[noOfWeapons];
int weaponProbabilities[6] = { 0,0,0,0,0,0 };
int weaponReferences[6] = { 0,0,0,0,0,0 };

//// extern Player plyr;

//// extern sf::RenderWindow App;
extern buffer_item itemBuffer[100];

//sf::Music encounterMusic;
//sf::SoundBuffer encBuffer, encBuffer2, encBuffer3, encBuffer4, encBuffer5;
//extern sf::Sound encSound;

extern int windowWidth;
extern int windowHeight;
extern int viewWidth;
extern int viewHeight;
extern int graphicMode;
extern int statPanelY;

//sf::Texture encImageSheet;
//sf::Sprite encImage;
string str, key, str2, prefix; // for message text
int encounterMenu;

int opponentNoAttacking;
int opponentNo;
int flashCount;
int encAnimation;
bool flashTextOn;
bool encounterNotHostile;
int encounterQuantity;
int curOpponent; // 0-7

//double round(double d){  return floor(d + 0.5);}
extern bool musicPlaying;


void drawEncounterView()
{
	drawEncounterAnimation();
	updateEncounterStatusText();
	if (graphicMode==2) drawConsoleBackground();
}

void updateEncounterStatusText()
{
	// Draw status line text
	string text;

	//SetFontColour(168, 241, 154, 255);
	SetFontColour(111, 159, 6, 255);


	if (encounterQuantity==1)
	{
			if (
			(Monsters[opponentNo].name.substr (0,1)=="A") ||
			(Monsters[opponentNo].name.substr (0,1)=="O") ||
			(Monsters[opponentNo].name.substr (0,1)=="I") ||
			(Monsters[opponentNo].name.substr (0,1)=="o") ||
			(Monsters[opponentNo].name.substr (0,1)=="U") ||
			(Monsters[opponentNo].name.substr (0,1)=="a") ||
			(Monsters[opponentNo].name.substr (0,1)=="i"))
			{text = "You encounter an "+Monsters[opponentNo].name + ".";;}
			else { text = "You encounter a "+Monsters[opponentNo].name + ".";; }
	}
	if (encounterQuantity>1) { text = "You encounter "+ itos(encounterQuantity) + " " +Monsters[opponentNo].pluName + "."; }
    int length = text.size();
    int xpos = (40 - length)/2;
    int y = (statPanelY/16)-1;
	drawText(xpos,5,text);
	SetFontColour(215, 215, 215, 255);
}


void chooseEncounter()
{
	// set player back to edge of square for drawing encounter image
	/*
	if (graphicMode==2) plyr.z_offset = 0.3;
	else plyr.z_offset = 1.5;
*/
	int monsterNo =0;

	if ((plyr.timeOfDay!=1) && (plyr.scenario==0))
	{
		//monsterNo = randn(0, 46);  pick random city encounter
		// If day
		int encCount = 0;
		int monsterProb = randn(0, 255);
		//int monsterProb = 253;
		for(int i = 0; i < 29; ++i) // 28???
		{
			if ((monsterProb >= encCount) && (monsterProb < dayEncTable[i].encProb+encCount))
			{ monsterNo = dayEncTable[i].encType; }
			encCount = encCount+dayEncTable[i].encProb;
		}
	}

	if ((plyr.timeOfDay==1) && (plyr.scenario==0))
	{
		// If night
		int encCount = 0;
		int monsterProb = randn(0, 255);
		for(int i = 0; i < 48; ++i)
		{
			if ((monsterProb >= encCount) && (monsterProb < nightEncTable[i].encProb+encCount))
			{ monsterNo = nightEncTable[i].encType; }
			encCount = encCount+nightEncTable[i].encProb;
		}
	}

	if (plyr.scenario==1) // Dungeon
	{
		//monsterNo = randn(0,73); // pick random dungeon encounter
		int encCount = 0;
		int monsterProb = randn(0, 255);
		for(int i = 0; i < 10; ++i)
		{
			if ((monsterProb >= encCount) && (monsterProb < wellLitEncTable[i].encProb+encCount))
			{ monsterNo = wellLitEncTable[i].encType; }
			encCount = encCount+wellLitEncTable[i].encProb;
		}
		if (monsterNo==0) monsterNo=1;
	}

	if ((plyr.scenario==1) && (plyr.map==4)) monsterNo = 19;

	runEncounter(monsterNo,1); // Monster type and number of monsters in encounter group
}

void runEncounter(int monsterNo, int monsterQuantity)
{
	if (graphicMode==2) plyr.z_offset = 0.3;
	else plyr.z_offset = 1.5;

	curOpponent = 0; // index in Opponents[] array 0 - 7
	opponentNo = monsterNo;

	plyr.encounterRef = monsterNo;
	plyr.encounterAnimationRef = Monsters[opponentNo].image;

	encounterQuantity = monsterQuantity;
	encounterNotHostile = true;
	if ((opponentNo == PHOENIX) || (opponentNo == VALKYRIE)  || (opponentNo == DWARF)) encounterNotHostile = false; // Good but hostile to humans
	bool musicPlaying = false;

	for(int i = 0; i < 8; ++i) // clear out old opponents from encounters you've left / run away from
	{
		Opponents[i].hp = 0;
	}

	encounterMenu = 1; // high level menu
	plyr.status = 3; // encounter!
	bool encounterStarted = false;
	flashCount = 0;
	int opponentCount = 0;
	flashTextOn = true;

	encAnimation = 1;

	// Determine any special encounter menu required for thief groupings, nobleman, pauper, knight etc
	if (opponentNo == THIEF) encounterMenu = 4;
	if (opponentNo == CUTTHROAT) encounterMenu = 4;
	if (opponentNo == BRIGAND) encounterMenu = 4;
	if (opponentNo == MASTER_THIEF) encounterMenu = 4;
	if (opponentNo == KNIGHT) encounterMenu = 6;
	if (opponentNo == PAUPER) encounterMenu = 7;



	while ((encounterMenu > 0) && (plyr.alive))
	{
		//if (!musicPlaying) { encSound.play(); musicPlaying = true; }
		drawEncounterView();

			if ( !encounterStarted )
		{
			opponent.alignment = 0;
			initMonster(opponentNo);
			opponent = Opponents[0];

			int opponentAlignment = Monsters[opponentNo].alignment;
			if ((plyr.scenario==0) && (opponent.alignment > 127))  { playEncounterTheme(0); }
			if ((plyr.scenario==0) && (opponent.alignment < 128))  { playEncounterTheme(1); }
			if ((plyr.scenario==1) && (opponent.alignment < 128))  { playEncounterTheme(2); }
			if ((plyr.scenario==1) && (opponent.alignment == 128)) { playEncounterTheme(3); }
			if ((plyr.scenario==1) && (opponent.alignment > 128))  { playEncounterTheme(4); }

			encounterStarted = true;
		}

		if (encounterMenu == 1)
		{
			cyText (1, "Battle Options");
			bText (12,3, "(1) Attack");
			bText (12,4, "(2) Charge");
			bText (12,5, "(3) Aimed Attack");
			bText (12,6, "(4) Transact");
			bText (12,7, "(5) Switch weapon");
			bText (12,8, "(0) Turn and run!");
		}

		if (encounterMenu == 2)
		{
			cyText (2, "Transact Options");
			bText (16,4, "(1) Offer");
			bText (16,5, "(2) Charm");
			bText (16,6, "(3) Trick");
			bText (16,7, "(4) Hail");
			bText (16,8, "(0) Leave");
		}

		if (encounterMenu == 3)
		{
			cyText (2, "You surprise the .");
			cyText (3, "Attempt to");
			bText (12,4, "(1) waylay the .");
			bText (12,5, "(2) snatch something.");
			bText (12,6, "(3) none of these.");
			bText (12,8, "(0) Leave.");
		}

		if (encounterMenu == 4) // thief grouping
		{
			str = "The "+ opponent.name +" demands:";
			cyText (2, str);
			cyText (4, "\"Stand and deliver.");
			bText (9,5, "Thy money or thy life!\"");
			bText (8,7, "Dost thou yield? (Y or N)");
		}

		if (encounterMenu == 6) // Knight
		{
			str = "The Knight demands:";
			cyText (2, str);
			cyText (4, "\"Yield the passage or face cold steel!\"");
			bText (8,7, "Dost thou yield? (Y or N)");
		}

		if (encounterMenu == 7) // Pauper
		{
			str = "The pauper pleads:@@\"Please help a fellow human@trapped in this foul world.\"";
			cyText (2, str);
		}


		if (encounterMenu == 5) // healer transact
		{
			cyText (2, "Would you like the healer to:");
			bText (8,4, "(1) Heal wounds (1 silver each)");
			bText (8,5, "(2) Cure diseases (100 silvers)");
			bText (8,6, "(3) Cure poisons (50 silvers)");
			bText (8,8, "(0) Nothing at all");
		}


	//	if (!musicPlaying) { encSound.play(); musicPlaying = true; }
//		if (plyr.diagOn) { displayMonsterDiag(); }

		updateDisplay(); // Refresh screen so drawn items are visible

		if (encounterMenu == 1)
		{
			key = getSingleKey();
			if  (key=="0")
			{
				if (plyr.fixedEncounter == true)
				{
					// Only running from fixed encounters moves player to previous x,y on map
					if (plyr.facing==1) { plyr.x = plyr.oldx; }
					if (plyr.facing==3) { plyr.x = plyr.oldx; }
					if (plyr.facing==2) { plyr.y = plyr.oldy; }
					if (plyr.facing==4) { plyr.y = plyr.oldy; }
					plyr.z_offset=1.0;
					plyr.fixedEncounter = false;
				}
				plyr.facing = randn(1,4);
				encounterMenu = 0;
			}
			if ( key=="P" ) { pauseEncounter(); }
			if  (key=="1") { playerAttack(1,0); } // standard attack
			if ( key=="2" ) { playerAttack(2,0.50); } // charge
			if ( key=="3" ) { playerAttack(3,0.50); } // Aimed attack
			if ( key=="4" ) { playerTransact(); }
			if ( key=="5" ) { playerSwitchWeapons(); }
			if ( key=="U" ) { selectItem(1); }
			if ( key=="D" ) { selectItem(2); }
			//if ( key=="X" ) { encounterQuantity = 0; opponentDeath(); }

		}

		if (encounterMenu == 2) // transact menu
		{
			key = getSingleKey();
			if ( key=="1" ) { playerOffer(); } // offer
			if ( key=="2" ) { playerCharm(); } // charm
			if ( key=="3" ) { playerTrick(); } // trick
			if ( key=="4" )
			{
				if ((opponentNo == 14) && (plyr.scenario==1)) {encounterMenu = 5;}
				else { playerHail(); }
			}
			if ( key=="0" ) { encounterMenu = 0; } // leave
		}

		if (encounterMenu == 4) // thief grouping menu
		{
			key = getSingleKey();
			if ( key=="Y" ) { thiefYield(); }
			if ( key=="N" ) { encounterNotHostile = false; encounterMenu = 1; }

		}

		if (encounterMenu == 6) // knight menu
		{
			key = getSingleKey();
			if ( key=="Y" ) { plyr.alignment++; if (plyr.alignment>255) plyr.alignment=255;encounterMenu = 0;  }
			if ( key=="N" ) { text("Have at you!"); plyr.alignment--; if (plyr.alignment<0) plyr.alignment=0; encounterNotHostile = false; encounterMenu = 1; }

		}

		if (encounterMenu == 7) // pauper menu
		{
			key = getSingleKey();
			if ( key=="SPACE" ) { encounterMenu = 1; }
		}

		if (encounterMenu == 5) // healer transact menu
		{
			key = getSingleKey();
			if  (key=="1" ) healerHealWounds();
			if  (key=="2" ) healerCureDiseases();
			if  (key=="3" ) healerCurePoisons();
			if ( key=="0" ) opponentLeaves();
		}

		//if (opponentCount == 399) { opponentAttack(); }
		if (opponentCount == 400) { opponentCount=0; }
		opponentCount++;

	}
	//updateDisplay();
	plyr.status = 1; // explore again
}


void playerSwitchWeapons()
{
	bool keynotpressed = true;
	bool weaponsSwitched = false;
	while ( keynotpressed )
	{
		drawEncounterView();
		if (!weaponsSwitched)
		{
			if (plyr.secWeapon == 255) { str = "Switching to bare hands"; }
			else

			{	str = "Switching to " + Weapons[(itemBuffer[plyr.secWeapon].index)].name + "."; }

			int oldPrimary = plyr.priWeapon;
			plyr.priWeapon = plyr.secWeapon;
			plyr.secWeapon = oldPrimary;
			weaponsSwitched = true;
		}
		cyText(4, str);
		updateDisplay();
		key = getSingleKey();
		if (key!="") { keynotpressed = false; }
	}
}

void playerTransact()
{
	if ((opponent.alignment>127) && (encounterNotHostile)) { encounterMenu = 2; }

	if ((opponent.alignment<128) || (!encounterNotHostile))
	{
		bool keynotpressed = true;
		while ( keynotpressed )
		{
			drawEncounterView();
			str = "The " + opponent.name + " seems uninterested.";
			cyText(4, str);
			updateDisplay();
			key = getSingleKey();
			if (key!="") { keynotpressed = false; }
		}
		opponentAttack();
	}

}


void playerHail()
{
	bool keynotpressed = true;
	int response = randn(1,15);
	if (response==1) str = "\"Run! The Devourer comes!\"";
	if (response==2) str = "The " + opponent.name + " mumbles@@something unintelligible.";
	if (response==3) str = "\"Beware of false alarms.\"";
	if (response==4) str = "\"No good deed ever goes unrewarded.\"";
	if (response==5) str = "\"Don't tell the peasants how good@@the pears are with the cheese!\"";
	if (response==6) str = "\"Prepare, the Apocalypse is soon.\"";
	if (response==7) str = "\"Greetings adventurer!\"";
	if (response==8) str = "\"Beware of Arena slavers!\"";
	if (response==9) str = "\"They say that the ghost of the dead@@king lurks in the Palace gardens.\"";
	if (response==10) str = "\"Seek out the guilds for learning.\"";
	if (response==11) str = "\"Few have survived the Trial of Kings\"";
	if (response==12) str = "\"The dead of the Arena haunt the@@ruined Five Blades tavern.\"";
	if (response==13) str = "\"The House of Shadows is the most@@mysterious of all the noble houses.\"";
	if (response==14) str = "\"Only those who have fought in@@the Great Arena can drink@@in the Block and Parry.\"";
	if (response==15) str = "\"A flaming torch can make@@an effective weapon.\"";

	if ((opponentNo == 17) && (plyr.scenario==1))
	{
		str = "The nobleman tosses you a coin@and says:@@\"Away knave! Get thyself a bath!\"";
		if (plyr.gender==2) str = "The nobleman tosses you a coin@and says@\"Away scullion! Get thyself a bath!\"";
		plyr.gold++;
	}
	while ( keynotpressed )
	{
		drawEncounterView();
		cyText(4, str);
		updateDisplay();
		key = getSingleKey();
		if (key!="") { keynotpressed = false; }
	}

	keynotpressed = true;
	while ( keynotpressed )
	{
		drawEncounterView();
		str = "The " + opponent.name + " leaves.";
		cyText(4, str);
		updateDisplay();
		key = getSingleKey();
		if (key!="") { keynotpressed = false; }
	}
	encounterMenu = 0;
}

void opponentLeaves()
{
	bool keynotpressed = true;
	while ( keynotpressed )
	{
		drawEncounterView();
		str = "The " + opponent.name + " leaves.";
		cyText(4, str);
		updateDisplay();
		key = getSingleKey();
		if (key!="") { keynotpressed = false; }
	}
	encounterMenu = 0;
}

void playerOffer()
{
	bool offermade = false;
	// opponentNo == 1
	int itemQuantity = 0;
	int itemRef = selectItem(3); // select an item in OFFER mode
	if ((itemRef > 999) && (itemRef != 9999)) itemQuantity = inputItemQuantity(3);
	if ((itemRef > 999) && (itemRef != 9999))
	{
		if ((itemRef==1000) && (plyr.food>0)) { if (itemQuantity > plyr.food) { itemQuantity = plyr.food; } plyr.food-=itemQuantity; offermade = true; }
		if ((itemRef==1001) && (plyr.water>0)) { if (itemQuantity > plyr.water) { itemQuantity = plyr.water; } plyr.water-=itemQuantity; offermade = true; }
		if ((itemRef==1002) && (plyr.torches>0)) { if (itemQuantity > plyr.torches) { itemQuantity = plyr.torches; } plyr.torches-=itemQuantity; offermade = true; }
		if ((itemRef==1003) && (plyr.timepieces>0)) { if (itemQuantity > plyr.timepieces) { itemQuantity = plyr.timepieces; } plyr.timepieces-=itemQuantity; offermade = true; }
		if ((itemRef==1004) && (plyr.compasses>0)) { if (itemQuantity > plyr.compasses) { itemQuantity = plyr.compasses; } plyr.compasses-=itemQuantity; offermade = true; }
		if ((itemRef==1005) && (plyr.keys>0)) { if (itemQuantity > plyr.keys) { itemQuantity = plyr.keys; } plyr.keys-=itemQuantity; offermade = true; }
		if ((itemRef==1006) && (plyr.crystals>0)) { if (itemQuantity > plyr.crystals) { itemQuantity = plyr.crystals; } plyr.crystals-=itemQuantity; offermade = true; }
		if ((itemRef==1007) && (plyr.gems>0)) { if (itemQuantity > plyr.gems) { itemQuantity = plyr.gems; } plyr.gems-=itemQuantity; offermade = true; }
		if ((itemRef==1008) && (plyr.jewels>0)) { if (itemQuantity > plyr.jewels) { itemQuantity = plyr.jewels; } plyr.jewels-=itemQuantity; offermade = true; }
		if ((itemRef==1009) && (plyr.gold>0)) { if (itemQuantity > plyr.gold) { itemQuantity = plyr.gold; } plyr.gold-=itemQuantity; offermade = true; }
		if ((itemRef==1010) && (plyr.silver>0)) { if (itemQuantity > plyr.silver) { itemQuantity = plyr.silver; } plyr.silver-=itemQuantity; offermade = true; }
		if ((itemRef==1011) && (plyr.copper>0)) { if (itemQuantity > plyr.copper) { itemQuantity = plyr.copper; } plyr.copper-=itemQuantity; offermade = true; }
	}

	if (itemRef<100)
	{
		// Remember corpses for undead!
		moveItem(itemRef,0); // move the inventory item to the void
	}

	if ((offermade) && (opponentNo == PAUPER))
	{
		// Paupers see items 1000 - 1011 as postive offers
		int pauperAcceptance = randn(0,6);
		if (pauperAcceptance > 1) { if (plyr.gender==1) str = "\"Bless you, kind sir.\""; if (plyr.gender==2) str = "\"Bless you, kind madam.\""; plyr.alignment += 1; }
		if (pauperAcceptance < 2) { str = "\"I was hoping for pears and cheese.\""; } // Ungrateful pauper, no alignmnent improvement
	}
	else
	{
		str = "The " + opponent.name + " leaves.";
	}
	text(str);
	encounterMenu = 0;
}


void playerCharm()
{
	opponent = Opponents[0];
	encounterNotHostile = false;
	bool charmSuccess = false;
	if ( (opponent.inte > 5) && (plyr.chr != 0) )
	{
		// Check for a successful Charm attempt
		int chrIntDifference = plyr.chr - opponent.inte;
		int charmProbability;
		if (chrIntDifference <= -128) { charmProbability = 1; }
		if ( (chrIntDifference >= -128) && (chrIntDifference < -64) )  { charmProbability = 2; }
		if ( (chrIntDifference >= -64) && (chrIntDifference < 0) )  { charmProbability = 7; }
		if ( (chrIntDifference >= 0) && (chrIntDifference < 64) )  { charmProbability = 25; }
		if ( (chrIntDifference >= 64) && (chrIntDifference < 128) )  { charmProbability = 50; }
		if ( (chrIntDifference >= 128) && (chrIntDifference < 192) )  { charmProbability = 70; }
		if (chrIntDifference >= 192) { charmProbability = 80; }

		int hitRoll = randn(1,100);
		if (hitRoll <= charmProbability) { charmSuccess = true; }


	}
	//if (!charmSuccess) { // 50% test that future charm attempts always fail }
	bool keynotpressed = true;
	while ( keynotpressed )
	{
		drawEncounterView();
		if ( charmSuccess) { str = "You charmed it!"; }
		else { str = "You failed to charm it!"; }
		cyText(4, str);
		updateDisplay();
		key = getSingleKey();
		if (key!="") { keynotpressed = false; }
	}
	if ( charmSuccess ) { Opponents[curOpponent].hp=0; awardExperience(opponentNo); plyr.chrPartials++; if (plyr.chrPartials==255) { plyr.chr++; plyr.chrPartials = 0; } encounterMenu = 0; }

	if ( !charmSuccess ) { opponentAttack(); encounterNotHostile = false; encounterMenu = 1; }
}


void playerTrick()
{
	encounterNotHostile = false;
	opponent = Opponents[0];
	bool trickSuccess = false;
	if ( (opponent.inte > 3) && (plyr.inte != 0) )
	{
		// Check for a successful trick attempt
		int intelligenceDifference = plyr.inte - opponent.inte;
		int trickProbability;
		if (intelligenceDifference <= -128) { trickProbability = 1; }
		if ( (intelligenceDifference >= -128) && (intelligenceDifference < -64) )  { trickProbability = 1; }
		if ( (intelligenceDifference >= -64) && (intelligenceDifference < 0) )  { trickProbability = 7; }
		if ( (intelligenceDifference >= 0) && (intelligenceDifference < 64) )  { trickProbability = 19; }
		if ( (intelligenceDifference >= 64) && (intelligenceDifference < 128) )  { trickProbability = 47; }
		if ( (intelligenceDifference >= 128) && (intelligenceDifference < 192) )  { trickProbability = 75; }
		if (intelligenceDifference >= 192) { trickProbability = 90; }

		int hitRoll = randn(1,100);
		if (hitRoll <= trickProbability) { trickSuccess = true; }


	}
	// TODO 50% test that future trick attempts always fail during this encounter
	if ( trickSuccess) { plyr.intPartials++; str = "You tricked it!"; }
	else { str = "You failed to trick it!"; }
	if (plyr.intPartials==255) { plyr.inte++; plyr.intPartials = 0; }
	bool keynotpressed = true;
	while ( keynotpressed )
	{
		drawEncounterView();
		cyText(4, str);
		updateDisplay();
		key = getSingleKey();
		if (key!="") { keynotpressed = false; }
	}
	if ( trickSuccess ) {  Opponents[curOpponent].hp=0; awardExperience(opponentNo); encounterMenu = 0; }
	if ( !trickSuccess ) { opponentAttack(); encounterNotHostile = false; encounterMenu = 1; }

}

void playerAttack(int attackType, float attackFactorBonus)
{
	encounterNotHostile = false;
	bool playerIsAttacking = true;
	bool hitSuccess;
	float attackFactor = 1.00;
	int weapon = itemBuffer[plyr.priWeapon].index;
	if (plyr.priWeapon==255) { weapon=0; } // bare hands weapon index 0
	// float attackFactorBonus = 0;
	if ((Weapons[weapon].useStrength==1))
	{
		//Calculate attack factor bonus if weapon uses Strength
		int strengthDifference = plyr.str - Opponents[curOpponent].str;
		if (strengthDifference <= -128) { attackFactorBonus += 0.0625; }
		if ( (strengthDifference >= -128) && (strengthDifference < -64) )  { attackFactorBonus += 0.125; }
		if ( (strengthDifference >= -64) && (strengthDifference < 0) )  { attackFactorBonus += 0.5; }
		if ( (strengthDifference >= 0) && (strengthDifference < 64) )  { attackFactorBonus += 0.75; }
		if ( (strengthDifference >= 64) && (strengthDifference < 128) )  { attackFactorBonus += 0.875; }
		if ( (strengthDifference >= 128) && (strengthDifference < 192) )  { attackFactorBonus += 1; }
		if (strengthDifference >= 192) { attackFactorBonus += 1; }
	}
	attackFactor += attackFactorBonus;

	// Hit probability
	int skillDifference = plyr.skl - Opponents[curOpponent].skl;
	int hitProbability;
	if (skillDifference <= -128) { hitProbability = 1; }
	if ( (skillDifference >= -128) && (skillDifference < -64) )  { hitProbability = 19; }
	if ( (skillDifference >= -64) && (skillDifference < 0) )  { hitProbability = 50; }
	if ( (skillDifference >= 0) && (skillDifference < 64) )  { hitProbability = 63; }
	if ( (skillDifference >= 64) && (skillDifference < 128) )  { hitProbability = 69; }
	if ( (skillDifference >= 128) && (skillDifference < 192) )  { hitProbability = 76; }
	if (skillDifference >= 192) { hitProbability = 100; }
	if (attackType==3) { hitProbability -= 5; } // penalty for charge attack
	int hitRoll = randn(1,100);
	if (hitRoll <= hitProbability) { hitSuccess = true; }
	else {  hitSuccess = false; }

	if (!hitSuccess)
	{
		if (attackType==3)
		{
			if (randn(1,2)==1) { str = "You wait for an opening."; }
			else { str = "You miss."; }

		}
		else
		{
			str = "You miss.";
		}
	}

	if (hitSuccess)
	{
		plyr.strPartials++; // Each successful hit contributes towards an extra strength point
		if (plyr.strPartials==255) { plyr.str++; plyr.strPartials = 0; }
		int damage = calculateWeaponDamage(weapon, attackFactor, 0);
		//damage = 80;
		if (damage != 1000) { Opponents[curOpponent].hp-=damage; increaseExperience(damage/2); }
		//damage [type] = Random [0; Round (base weapon damage [type] * attack factor)]
		str = "You attack the " + Opponents[curOpponent].name + "@with "+ Weapons[weapon].name + "@for " + itos(damage) + ".";
		if (damage==0) { str = "You attack the " + Opponents[curOpponent].name + "@with "+ Weapons[weapon].name + "@which has no effect!"; }
		if ((plyr.scenario==0) && (damage==1000)) { str = "You attack the " + Opponents[curOpponent].name + "@with "+ Weapons[weapon].name + "@which is stopped by its " + Opponents[curOpponent].armorText + "."; }
		if ((plyr.scenario==1) && (damage==1000)) { str = "You attack the " + Opponents[curOpponent].name + "@with "+ Weapons[weapon].name + "@which is stopped by its armour."; }
	}

	while ( playerIsAttacking )
	{
		drawEncounterView();
		cyText(4, str);
		updateDisplay();
		key = getSingleKey();
		if (key!="") { playerIsAttacking = false; }
	}
	if ( Opponents[curOpponent].hp<0) {opponentDeath(); }
	else
	{
		opponentAttack(); // add chance of parry reduction here
	}
}

void opponentDeath()
{
	//int experienceMultiplier = 0;
	bool keynotpressed = true;
	while ( keynotpressed )
	{
		drawEncounterView();
		str = "The " + Opponents[0].name + " has died!";

		if (plyr.scenario==1) { str = "The " + Opponents[0].name + " " + Opponents[0].armorText + "."; }
		cyText(4, str);
		updateDisplay();
		key = getSingleKey();
		if (key!="") { keynotpressed = false; }
	}

	awardExperience(opponentNo);
	updateOpponents();

	if (encounterQuantity==0)
	{
	    switch(plyr.special) // Stat bonus for defeating The Seven Undead Knights
		{
		    // Should check that you've defeated an undead knight and not just any encounter!
			case 0x80: plyr.sta++; break;
			case 0x81: plyr.chr++; break;
			case 0x82: plyr.str++; break;
			case 0x83: plyr.inte++; break;
			case 0x84: plyr.wis++; break;
			case 0x85: plyr.skl++; break;
			case 0x86: plyr.str++; break;
		}

		if (opponentNo==71) // troll tyrant killed
		{
			if (plyr.trollsReforged == false){ plyr.trollsDefeated = true; createQuestItem(0); getItems(); }
			else { plyr.trollsDefeated = true; createQuestItem(2); getItems(); }
		}
		if (opponentNo==70) // goblin lord killed
		{
			if (plyr.goblinsReforged == false) { plyr.goblinsDefeated = true; createQuestItem(1); getItems(); }
			else { plyr.goblinsDefeated = true; createQuestItem(2); }
		}
		plyr.status = 1; // explore again required to display any treasure on status line
		checkTreasure();
		//checkTreasureWeapon();

		if (plyr.fixedEncounter==true)
		{
			// fixed encounter killed

			plyr.fixedEncounters[plyr.fixedEncounterRef] = true;
			plyr.fixedEncounter = false;
		}
		encounterMenu = 0;
	}

	if (encounterQuantity>0) opponentAttack();

}

void updateOpponents()
{
	encounterQuantity=0;
	for(int i = 0; i < 8; ++i) //
	{

		if (Opponents[i].hp>0) encounterQuantity++;
	}
	curOpponent=255;
	int idx=0;
	 while (curOpponent==255)
	 {
		if (Opponents[idx].hp>0) curOpponent=idx;
		idx++;
	 }
}

void opponentAttack()
{
	bool opponentIsAttacking;
	bool hitSuccess;
	weapon opponentWeapon;
	opponentNoAttacking = 0;

	for(int i = 0; i < 8; ++i) // cycle through possible 1-8 opponents
	{
		opponentIsAttacking = true;


		if ((Opponents[i].hp>0) && (plyr.hp>-1))
		{
			opponentNoAttacking++;

			if (opponentNoAttacking==1) prefix="The ";
			if (opponentNoAttacking==2) prefix="2nd ";
			if (opponentNoAttacking==3) prefix="3rd ";
			if (opponentNoAttacking==4) prefix="4th ";
			if (opponentNoAttacking==5) prefix="5th ";
			if (opponentNoAttacking==6) prefix="6th ";
			if (opponentNoAttacking==7) prefix="7th ";
			if (opponentNoAttacking==8) prefix="8th ";

			int chosenWeapon = opponentChooseWeapon();
			opponentWeapon = Weapons[chosenWeapon];
			//opponentWeapon = Weapons[opponent.weapon1];

			// Hit probability
			int skillDifference = opponent.skl - plyr.skl;
			int hitProbability;
			if (skillDifference <= -128) { hitProbability = 1; }
			if ( (skillDifference >= -128) && (skillDifference < -64) )  { hitProbability = 19; }
			if ( (skillDifference >= -64) && (skillDifference < 0) )  { hitProbability = 50; }
			if ( (skillDifference >= 0) && (skillDifference < 64) )  { hitProbability = 63; }
			if ( (skillDifference >= 64) && (skillDifference < 128) )  { hitProbability = 69; }
			if ( (skillDifference >= 128) && (skillDifference < 192) )  { hitProbability = 76; }
			if (skillDifference >= 192) { hitProbability = 100; }
			int hitRoll = randn(1,100);
			if (hitRoll <= hitProbability) { hitSuccess = true; }
			else {  hitSuccess = false; }

			if (!hitSuccess)
			{
				str = prefix + opponent.name + " misses.";
			}

			if (hitSuccess)
			{
				//int damage = randn(1,6); // CHANGE!!!
				if (opponentNo==GIANT_RAT) { plyr.diseases[0] = 1;} // Rabies
				float attackFactor = 1.0; // change!
				int damage = calculateWeaponDamage(chosenWeapon,attackFactor, 1);
				if (damage!=1000) { plyr.hp-=damage; }
				str = prefix + opponent.name + " " + opponentWeapon.descMon + "@you with "+ opponentWeapon.name + "@for " + itos(damage) + ".";
				if (damage==0) { str = prefix + opponent.name + " " + opponentWeapon.descMon + "@you with "+ opponentWeapon.name + "@which has no effect!"; }
				//if (damage==1000) { str = prefix + opponent.name + " " + opponentWeapon.descMon + "@you with "+ opponentWeapon.name + "@which is stopped by your skin!"; }
			}

			while ( opponentIsAttacking )
			{
				drawEncounterView();
				cyText(4, str);
				//str2 = itos(opponent.w1) + " " + itos(opponent.w2) + " " + itos(opponent.w3) + " " + itos(opponent.w4) + " " + itos(opponent.w5) + " " + itos(opponent.w6);
				//cyText(8, str2);
				updateDisplay();
				key = getSingleKey();
				if (key!="") { opponentIsAttacking = false; }
			}
			if (plyr.hp<0) { plyr.alive=false; }
		}

	}
}




int calculateWeaponDamage(int weaponNo, float attackFactor, int attacker)
{
	// attacker - 0 = player, 1 = monster
	int weaponDamageValues[11];
	weaponDamageValues[0] = Weapons[weaponNo].blunt;
	weaponDamageValues[1] = Weapons[weaponNo].sharp;
	weaponDamageValues[2] = Weapons[weaponNo].earth;
	weaponDamageValues[3] = Weapons[weaponNo].air;
	weaponDamageValues[4] = Weapons[weaponNo].fire;
	weaponDamageValues[5] = Weapons[weaponNo].water;
	weaponDamageValues[6] = Weapons[weaponNo].power;
	weaponDamageValues[7] = Weapons[weaponNo].magic;
	weaponDamageValues[8] = Weapons[weaponNo].good;
	weaponDamageValues[9] = Weapons[weaponNo].evil;
	weaponDamageValues[10] = Weapons[weaponNo].cold;

	int armorValues[11] = { 0,0,0,0,0,0,0,0,0,0,0 };
	// Need to add modifier for player armor values & armor body parts

	int armors[11]; // holds results of rolling for armor protection
	if (attacker==0) // Player attacking
	{
		armorValues[0] = opponent.aBlunt;
		armorValues[1] = opponent.aSharp;
		armorValues[2] = opponent.aEarth;
		armorValues[3] = opponent.aAir;
		armorValues[4] = opponent.aFire;
		armorValues[5] = opponent.aWater;
		armorValues[6] = opponent.aPower;
		armorValues[7] = opponent.aMagic;
		armorValues[8] = opponent.aGood;
		armorValues[9] = opponent.aEvil;
		armorValues[10] = opponent.aCold;

		int armorIndex = 0;
		while (armorIndex < 11)
		{
			int noDice = (armorValues[armorIndex] & 0xf0) >> 4;
			int noSides = (armorValues[armorIndex] & 0x0f);
			armors[armorIndex] = rollDice(noDice, noSides);
			armorIndex++;
		}
	}



	int damages[11] = { 0,0,0,0,0,0,0,0,0,0,0 }; // holds results of rolling for damage

	int damageIndex = 0; // 0 is blunt, 1 is sharp, 11 is cold - 11 damage types in total
	while (damageIndex < 11)
	{
		int noDice = (weaponDamageValues[damageIndex] & 0xf0) >> 4;
		int noSides = (weaponDamageValues[damageIndex] & 0x0f);

		//int currentDamage = round((weaponDamageValues[damageIndex])* attackFactor);
		damages[damageIndex] = rollDice(noDice, noSides);
		if (armorValues[damageIndex]==0xff) { damages[damageIndex] = 0; }
		if (armorValues[damageIndex]==0xf0) { damages[damageIndex] = damages[damageIndex]*-1; }
		if (armorValues[damageIndex]==0xff) { damages[damageIndex] = damages[damageIndex]*2; }
		damageIndex++;
	}

	// Compare weapon damages against ancounter armour values inc. vulnerabilities and invulnerabilities
	// 0xff = invulnerable.
	// 0xf0 = absorbs power from this damage type.
	// 0x0f = takes double damage from this damage type.
	if (attacker==0) // Player attacking
	{
		for(int i = 0; i < 11; ++i) // number of damages to compare against armors
		{

			damages[i] -= armors[i];

			if ( damages[i] < 0 ) { damages[i] = 0; }
		}
		//totalDamage = damages[0] + damages[1] + damages[2] + damages[3] + damages[4] + damages[5] + damages[6] + damages[7] + damages[8];
		//if (totalDamage==0) { return 1000; }
		//if (totalDamage >0) { return totalDamage; }
	}


	//std::cout << "B:" << damages[0] << " S:" << damages[1] << " E:" << damages[2] << " A:" << damages[3] << " F:" << damages[4] << " W:" << damages[5] << " P:" << damages[6] << " M:" << damages[7] << " G:" << damages[8] << " E:" << damages[9] << " C:" << damages[10] << std::endl;
	int totalDamage = damages[0]+damages[1]+damages[2]+damages[3]+damages[4]+damages[5]+damages[6]+damages[7]+damages[8]+damages[9]+damages[10];
	return totalDamage;

}

int opponentChooseWeapon()
{
	weaponProbabilities[0] = opponent.c1;
	weaponProbabilities[1] = opponent.c2;
	weaponProbabilities[2] = opponent.c3;
	weaponProbabilities[3] = opponent.c4;
	weaponProbabilities[4] = opponent.c5;
	weaponProbabilities[5] = opponent.c6;

	weaponReferences[0] = opponent.w1;
	weaponReferences[1] = opponent.w2;
	weaponReferences[2] = opponent.w3;
	weaponReferences[3] = opponent.w4;
	weaponReferences[4] = opponent.w5;
	weaponReferences[5] = opponent.w6;

	int chosenWeaponNo = 255;
	int weaponProbability = randn(1,100);
	int weaponProbabilityTotal = 0;
	int weaponIndex = 0;
	//int weaponIndexProbability = 0;
	while (chosenWeaponNo == 255)
	{
		weaponProbabilityTotal += weaponProbabilities[weaponIndex];
		if ( weaponProbability <= weaponProbabilityTotal ) { chosenWeaponNo = weaponReferences[weaponIndex]; }
		if ( weaponIndex == 6) { chosenWeaponNo = 0; } // error weapon!
		weaponIndex++;
	}
	return chosenWeaponNo;
}


void initMonster(int monsterNo)
{
	for (int a = 0; a < encounterQuantity; ++a) // Typically 1 but up to 8
	{
		Opponents[a] = Monsters[monsterNo]; // copy monster details to current Opponents[a] object
		Opponents[a].hp += randn(0,Monsters[monsterNo].randomHP);
		Opponents[a].str += randn(0,Monsters[monsterNo].randomStrength);
		Opponents[a].skl += randn(0,Monsters[monsterNo].randomSkill);
		Opponents[a].inte += randn(0,Monsters[monsterNo].randomIntelligence);
		Opponents[a].spd += randn(0,Monsters[monsterNo].randomSpeed);
		Opponents[a].maxHP = Opponents[a].hp;

		if (monsterNo==DOPPLEGANGER)
		{
			// Doppelganger
			Opponents[a].hp = plyr.hp;
			Opponents[a].maxHP = plyr.hp;
			Opponents[a].str = plyr.str;
			Opponents[a].skl = plyr.skl;
			Opponents[a].inte = plyr.inte;
			Opponents[a].spd = plyr.speed;
			Opponents[a].w1 = itemBuffer[plyr.priWeapon].index;
			if (plyr.priWeapon==255) Opponents[a].w1=0; // bare hands
			Opponents[a].c1 = 100;
		}
	}
}





int Hex2Dec(std::string s)
{
    std::stringstream ss(s);
    int i;
    ss >> std::hex >> i;
    return i;
}


void loadWeapons()
{

	std::ifstream instream;
	std::string junk,junk2, data;

	instream.open("data/map/weapons.txt");
	if( !instream )
	{
      cerr << "Error: Weapons file could not be loaded" << endl;
	}

	for(int i = 0; i < noOfWeapons; ++i) // number of weapons
	{
		string junk, line, text;
		int weapon_attributes =26; // should be 26
		string::size_type idx;
		getline(instream, junk); // read first line as blank
		for (int a = 0; a < weapon_attributes; ++a) // number of attributes - test for 33
		{
			getline(instream, line);
			idx = line.find('=');
			text = line.substr(idx+2);
			//cout << a << ", " << text << "\n";
			if (a==0) { Weapons[i].article = text; }
			if (a==1) { Weapons[i].name = text; }
			if (a==2) { Weapons[i].desc = text; }
			if (a==3) { Weapons[i].descMon = text; }
			if (a==4) { Weapons[i].type = atoi(text.c_str()); }
			if (a==5) { Weapons[i].parry = atoi(text.c_str()); }
			if (a==6) { Weapons[i].bonusToHit = atoi(text.c_str()); }
			if (a==7) { Weapons[i].minStrength = atoi(text.c_str()); }
			if (a==8) { Weapons[i].minDexterity = atoi(text.c_str()); }
			if (a==9) { Weapons[i].useStrength = atoi(text.c_str()); }
			if (a==10) { Weapons[i].blunt = Hex2Dec(text.c_str()); }
			if (a==11) { Weapons[i].sharp = Hex2Dec(text.c_str()); }
			if (a==12) { Weapons[i].earth = Hex2Dec(text.c_str()); }
			if (a==13) { Weapons[i].air = Hex2Dec(text.c_str()); }
			if (a==14) { Weapons[i].fire = Hex2Dec(text.c_str()); }
			if (a==15) { Weapons[i].water = Hex2Dec(text.c_str()); }
			if (a==16) { Weapons[i].power = Hex2Dec(text.c_str()); }
			if (a==17) { Weapons[i].magic = Hex2Dec(text.c_str()); }
			if (a==18) { Weapons[i].good = Hex2Dec(text.c_str()); }
			if (a==19) { Weapons[i].evil = Hex2Dec(text.c_str()); }
			if (a==20) { Weapons[i].cold = Hex2Dec(text.c_str()); }
			if (a==21) { Weapons[i].weight = atoi(text.c_str()); }
			if (a==22) { Weapons[i].maxHP = atoi(text.c_str()); }
			if (a==23) { Weapons[i].minAlignment = atoi(text.c_str()); }
			if (a==24) { Weapons[i].twoHanded = atoi(text.c_str()); }
			if (a==25) { Weapons[i].ammo = atoi(text.c_str()); }
		}
		getline(instream, junk);
		//cout << "\n\n";
	}
	instream.close();
}



void checkTreasureWeapon()
{

}


void checkTreasure()
{
	bool foundTreasure = false;
	int no_found = 0;
	int found = 0;

	// Check to see if the opponent was carrying a weapon (as opposed to claws or teeth)
	// Only type 2 weapons can be dropped - type 1 refers to natural weapons such as bites, tails, claws, spells
	// TODO check for other weapons than opponent.w1
	int weapon = opponent.w1; // Modify
	if (Weapons[weapon].type==2)
	{
		createWeapon(weapon); // Create a new instance of this weapon type on the floor
		foundTreasure = true; // need to ensure that only weapons get created!
	}


	no_found = randn(0,opponent.tFood);
	found = randn(0,50);
	if ((no_found>0) && (found<=plyr.treasureFinding)) { createGenericItem(1,no_found); foundTreasure = true; }

	no_found = randn(0,opponent.tWater);
	found = randn(0,50);
	if ((no_found>0) && (found<=plyr.treasureFinding)) { createGenericItem(2,no_found); foundTreasure = true; }

	no_found = randn(0,opponent.tTorches);
	found = randn(0,50);
	if ((no_found>0) && (found<=plyr.treasureFinding)){ createGenericItem(3,no_found); foundTreasure = true; }

	no_found = randn(0,opponent.tTimepieces);
	found = randn(0,50);
	if ((no_found>0) && (found<=plyr.treasureFinding)) { createGenericItem(4,no_found); foundTreasure = true; }

	no_found = randn(0,opponent.tCompasses);
	found = randn(0,50);
	if ((no_found>0) && (found<=plyr.treasureFinding)) { createGenericItem(5,no_found); foundTreasure = true; }

	no_found = randn(0,opponent.tKeys);
	found = randn(0,50);
	if ((no_found>0) &&(found<=plyr.treasureFinding)) { createGenericItem(6,no_found); foundTreasure = true; }

	no_found = randn(0,opponent.tCrystals);
	found = randn(0,50);
	if ((no_found>0) && (found<=plyr.treasureFinding)) { createGenericItem(7,no_found); foundTreasure = true; }

	no_found = randn(0,opponent.tGems);
	found = randn(0,50);
	if ((no_found>0) && (found<=plyr.treasureFinding)) { createGenericItem(8,no_found); foundTreasure = true; }

	no_found = randn(0,opponent.tJewels);
	found = randn(0,50);
	if ((no_found>0) && (found<=plyr.treasureFinding)) { createGenericItem(9,no_found); foundTreasure = true; }

	no_found = randn(0,opponent.tGold);
	found = randn(0,50);
	if ((no_found>0) && (found<=plyr.treasureFinding)) { createGenericItem(10,no_found); foundTreasure = true; }

	no_found = randn(0,opponent.tSilver);
	found = randn(0,50);
	if ((no_found>0) && (found<=plyr.treasureFinding)) { createGenericItem(11,no_found); foundTreasure = true; }

	no_found = randn(0,opponent.tCopper);
	found = randn(0,50);
	if ((no_found>0) && (found<=plyr.treasureFinding)) { createGenericItem(12,no_found); foundTreasure = true; }

    found = randn(0,10);
	if (found>3)
    {
        // No checking for suitability of encounter to be carrying potions yet
        foundTreasure = true;
        int potionType = randn(0,43);
        int potionKnown = randn(0,100);
        int potionRef = createPotion(potionType);
        if (potionKnown>90) itemBuffer[potionRef].hp = 1; // Potion identified or labelled
    }



    if ((foundTreasure) && (plyr.treasureFinding>5)) { plyr.treasureFinding--; }
	if (foundTreasure) getItems();
}

void thiefYield()
{

	bool keynotpressed = true;

	if ((plyr.gold==0) && (plyr.silver==0) && (plyr.copper==0) && (plyr.gems==0) && (plyr.jewels==0))
	{
		str = "\"Thou pitiful fool! Have a copper.\"";
		plyr.copper++;
	}
	else
	{
		str = "\"Farewell pidgeon.\"";
		plyr.gold = 0; plyr.silver = 0; plyr.copper = 0; plyr.gems = 0; plyr.jewels = 0;
	}

	while ( keynotpressed )
	{
		drawEncounterView();
		cyText(4, str);
		updateDisplay();
		key = getSingleKey();
		if (key!="") { keynotpressed = false; }
	}

	encounterMenu = 0;

}


void healerCureDiseases()
{
	bool keynotpressed = true;
	// Clear all the disease flags

	if (!checkCoins(0,100,0))
	{
		// Insufficient funds
		plyr.gold = 0;
		plyr.silver = 0;
		plyr.copper = 0;
		while ( keynotpressed )
		{
			drawEncounterView();
			cyText(4, "The Healer grumbles:@@Thy purse is too small, however...");
			updateDisplay();
			key = getSingleKey();
			if (key!="") { keynotpressed = false; }
		}
	}
	else
	{
		deductCoins(0,100,0);
	}

	keynotpressed = true;
	while ( keynotpressed )
	{
		drawEncounterView();
		cyText(4, "The Healer lays his@hands upon you.");
		updateDisplay();
		key = getSingleKey();
		if (key!="") { plyr.diseases[0] = 0; keynotpressed = false; }
	}
	opponentLeaves();
}


void healerCurePoisons()
{
	bool keynotpressed = true;
	// Clear all the poison flags

	if (!checkCoins(0,50,0))
	{
		// Insufficient funds
		plyr.gold = 0;
		plyr.silver = 0;
		plyr.copper = 0;
		while ( keynotpressed )
		{
			drawEncounterView();
			cyText(4, "The Healer grumbles:@@Thy purse is too small, however...");
			updateDisplay();
			key = getSingleKey();
			if (key!="") { keynotpressed = false; }
		}
	}
	else
	{
		deductCoins(0,50,0);
	}

	keynotpressed = true;
	while ( keynotpressed )
	{
		drawEncounterView();
		cyText(4, "The Healer lays his@hands upon you.");
		updateDisplay();
		key = getSingleKey();
		if (key!="") { plyr.poison[0] = 0; plyr.poison[1] = 0; plyr.poison[2] = 0; plyr.poison[3] = 0; keynotpressed = false; }
	}
	opponentLeaves();
}




int inputNumber()
{
	string str;
	string inputText = "";
	int maxNumberSize = 6;
	bool enterKeyNotPressed = true;
	while ( enterKeyNotPressed )
	{
		drawEncounterView();
		cyText(3, "Cure how many hits at@@ 1 silver each?");
		str = ">" + inputText + "_";
		bText(10,7, str);
		updateDisplay();
		key = getSingleKey();
		if ( (key=="0") || (key=="1") || (key=="2") || (key=="3") || (key=="4") || (key=="5") || (key=="6") || (key=="7") || (key=="8") || (key=="9") )
		{
			int numberLength = inputText.size();
			if (numberLength < maxNumberSize) { inputText = inputText + key; }
		}
		if (key=="BACKSPACE")
		{
			int numberLength = inputText.size();
			if (numberLength!=0)
			{
			  int numberLength = inputText.size();
			  inputText = inputText.substr(0,(numberLength-1));
			}
		}
		if (key=="RETURN") { enterKeyNotPressed = false; }
	}
	int value = atoi(inputText.c_str());
	return value;
}




void healerHealWounds()
{
	int hpToHeal = inputNumber();
	bool keynotpressed = true;

	if (hpToHeal>0)
	{
		keynotpressed = true;
		if (!checkCoins(0,hpToHeal,0))
		{
			// Insufficient funds
			plyr.gold = 0;
			plyr.silver = 0;
			plyr.copper = 0;
			while ( keynotpressed )
			{
				drawEncounterView();
				cyText(4, "The Healer grumbles:@@Thy purse is too small, however...");
				updateDisplay();
				key = getSingleKey();
				if (key!="") { keynotpressed = false; }
			}
		}
		else
		{
			deductCoins(0,hpToHeal,0);
		}

		keynotpressed = true;
		while ( keynotpressed )
		{
			drawEncounterView();
			cyText(4, "The Healer lays his@hands upon you.");
			updateDisplay();
			key = getSingleKey();
			if (key!="") { keynotpressed = false; }
		}
		plyr.hp = plyr.hp + hpToHeal;
		if (plyr.hp > plyr.maxhp) { plyr.hp = plyr.maxhp; }
		opponentLeaves();
	}
}



void loadEncounters()
{
	std::ifstream instream;
	std::string junk, data, junk2;
	instream.open("data/map/encounters.txt");
	if( !instream )
	{
      cerr << "Error: Encounters file could not be loaded" << endl;
	}

	for(int i = 0; i < noOfEncounters; ++i) // number of monsters
	{
		string junk, line, text;
		int attributes = 48; // number of lines making up each record
		string::size_type idx;
		getline(instream, junk); // read first line as blank
		for (int a = 0; a < attributes; ++a) // number of attributes per record
		{
			getline(instream, line);
			idx = line.find(':');
			text = line.substr(idx+1);
			//if (a==0) cout << text << " = " << i << ",\n";

			if (a==0) { Monsters[i].name = text; }
			if (a==1) { Monsters[i].pluName = text; }
			if (a==2) { Monsters[i].armorText = text; }
			if (a==3) { Monsters[i].hp = atoi(text.c_str()); }
			if (a==4) { Monsters[i].alignment = atoi(text.c_str()); }
			if (a==5) { Monsters[i].image = atoi(text.c_str()); }

			if (a==6) { Monsters[i].sta = atoi(text.c_str()); }
			if (a==7) { Monsters[i].cha = atoi(text.c_str());}
			if (a==8) { Monsters[i].str = atoi(text.c_str());}
			if (a==9) { Monsters[i].inte = atoi(text.c_str());}
			if (a==10) { Monsters[i].wis = atoi(text.c_str()); }
			if (a==11) { Monsters[i].skl = atoi(text.c_str());}
			if (a==12) { Monsters[i].spd = atoi(text.c_str());}

			if (a==13) { Monsters[i].tFood = atoi(text.c_str()); }
			if (a==14) { Monsters[i].tWater = atoi(text.c_str());}
			if (a==15) { Monsters[i].tTorches = atoi(text.c_str());}
			if (a==16) { Monsters[i].tTimepieces = atoi(text.c_str()); }
			if (a==17) { Monsters[i].tCompasses = atoi(text.c_str()); }
			if (a==18) { Monsters[i].tKeys = atoi(text.c_str()); }
			if (a==19) { Monsters[i].tCrystals = atoi(text.c_str());}
			if (a==20) { Monsters[i].tGems = atoi(text.c_str()); }
			if (a==21) { Monsters[i].tJewels = atoi(text.c_str());}
			if (a==22) { Monsters[i].tGold = atoi(text.c_str());}
			if (a==23) { Monsters[i].tSilver = atoi(text.c_str()); }
			if (a==24) { Monsters[i].tCopper = atoi(text.c_str()); 	}

			if (a==25) { Monsters[i].aBlunt = Hex2Dec(text.c_str()); }
			if (a==26) { Monsters[i].aSharp = Hex2Dec(text.c_str()); }
			if (a==27) { Monsters[i].aEarth = Hex2Dec(text.c_str()); }
			if (a==28) { Monsters[i].aAir = Hex2Dec(text.c_str()); }
			if (a==29) { Monsters[i].aFire = Hex2Dec(text.c_str()); }
			if (a==30) { Monsters[i].aWater = Hex2Dec(text.c_str()); }
			if (a==31) { Monsters[i].aPower = Hex2Dec(text.c_str()); }
			if (a==32) { Monsters[i].aMagic = Hex2Dec(text.c_str()); }
			if (a==33) { Monsters[i].aGood = Hex2Dec(text.c_str()); }
			if (a==34) { Monsters[i].aEvil = Hex2Dec(text.c_str()); }
			if (a==35) { Monsters[i].aCold = Hex2Dec(text.c_str()); }

			if (a==36) { Monsters[i].w1 = atoi(text.c_str());}
			if (a==37) { Monsters[i].w2 = atoi(text.c_str());}
			if (a==38) { Monsters[i].w3 = atoi(text.c_str());}
			if (a==39) { Monsters[i].w4 = atoi(text.c_str());}
			if (a==40) { Monsters[i].w5 = atoi(text.c_str());}
			if (a==41) { Monsters[i].w6 = atoi(text.c_str());}

			if (a==42) { Monsters[i].c1 = atoi(text.c_str()); }
			if (a==43) { Monsters[i].c2 = atoi(text.c_str());}
			if (a==44) { Monsters[i].c3 = atoi(text.c_str());}
			if (a==45) { Monsters[i].c4 = atoi(text.c_str());}
			if (a==46) { Monsters[i].c5 = atoi(text.c_str());}
			if (a==47) { Monsters[i].c6 = atoi(text.c_str());}

		}
	}
	instream.close();
}


/*
void loadCityMonsters()
{

	std::ifstream instream;
	std::string junk,junk2, data;

	instream.open("data/map/cityMonsters.txt");
	if( !instream )
	{
      cerr << "Error: City monsters file could not be loaded" << endl;
	}

	for(int i = 0; i < 47; ++i) // number of monsters - test for 2
	{
		string junk, line, text;
		int monster_attributes = 45; // should be 45
		string::size_type idx;
		getline(instream, junk); // read first line as blank
		for (int a = 0; a < monster_attributes; ++a) // number of attributes - test for 33
		{
			getline(instream, line);
			idx = line.find(':');
			text = line.substr(idx+1);
			//cout << a << ", " << text << "\n";
			if (a==0) { Monsters[i].name = text; }
			if (a==1) { Monsters[i].armorText = text; }
			if (a==2) { Monsters[i].behaviour = atoi(text.c_str()); }
			if (a==3) { Monsters[i].alignment = atoi(text.c_str()); }
			if (a==4) { Monsters[i].stealth = atoi(text.c_str()); }
			if (a==5) { Monsters[i].str = atoi(text.c_str()); }
			if (a==6) { Monsters[i].randomStrength = atoi(text.c_str()); }
			if (a==7) { Monsters[i].skl = atoi(text.c_str()); }
			if (a==8) { Monsters[i].randomSkill = atoi(text.c_str()); }
			if (a==9) { Monsters[i].inte = atoi(text.c_str()); }
			if (a==10) { Monsters[i].randomIntelligence = atoi(text.c_str()); }
			if (a==11) { Monsters[i].spd = atoi(text.c_str()); }
			if (a==12) { Monsters[i].randomSpeed = atoi(text.c_str()); }
			if (a==13) { Monsters[i].hp = atoi(text.c_str()); }
			if (a==14) { Monsters[i].randomHP = atoi(text.c_str()); }
			if (a==15) { Monsters[i].image = atoi(text.c_str()); }
			if (a==16) { Monsters[i].image2 = atoi(text.c_str()); }

			if (a==17) { Monsters[i].aBlunt = Hex2Dec(text.c_str()); }
			if (a==18) { Monsters[i].aSharp = Hex2Dec(text.c_str());  }
			if (a==19) { Monsters[i].aEarth = Hex2Dec(text.c_str()); }
			if (a==20) { Monsters[i].aAir = Hex2Dec(text.c_str()); }
			if (a==21) { Monsters[i].aFire = Hex2Dec(text.c_str()); }
			if (a==22) { Monsters[i].aWater = Hex2Dec(text.c_str()); }
			if (a==23) { Monsters[i].aPower = Hex2Dec(text.c_str()); }
			if (a==24) { Monsters[i].aMagic = Hex2Dec(text.c_str()); }
			if (a==25) { Monsters[i].aGood = Hex2Dec(text.c_str()); }

			if (a==26) { Monsters[i].tPotions = atoi(text.c_str()); }
			if (a==27) { Monsters[i].tEquipment = atoi(text.c_str()); }
			if (a==28) { Monsters[i].tCopper = atoi(text.c_str()); }
			if (a==29) { Monsters[i].tSilver = atoi(text.c_str()); }
			if (a==30) { Monsters[i].tGold = atoi(text.c_str()); }
			if (a==31) { Monsters[i].tGems = atoi(text.c_str()); }
			if (a==32) { Monsters[i].tJewels = atoi(text.c_str()); }

			if (a==33) { Monsters[i].w1 = atoi(text.c_str()); }
			if (a==34) { Monsters[i].w2 = atoi(text.c_str()); }
			if (a==35) { Monsters[i].w3 = atoi(text.c_str()); }
			if (a==36) { Monsters[i].w4 = atoi(text.c_str()); }
			if (a==37) { Monsters[i].w5 = atoi(text.c_str()); }
			if (a==38) { Monsters[i].w6 = atoi(text.c_str()); }

			if (a==39) { Monsters[i].c1 = atoi(text.c_str()); }
			if (a==40) { Monsters[i].c2 = atoi(text.c_str()); }
			if (a==41) { Monsters[i].c3 = atoi(text.c_str()); }
			if (a==42) { Monsters[i].c4 = atoi(text.c_str()); }
			if (a==43) { Monsters[i].c5 = atoi(text.c_str()); }
			if (a==44) { Monsters[i].c6 = atoi(text.c_str()); }

		}
		getline(instream, junk);
		//cout << "\n\n";
	}
	instream.close();
}
*/

void pauseEncounter()
{
	string txt;
	string key = "";
	while (key!="SPACE")
	{
			drawEncounterView();
			txt = "(Paused)@@@@@(Press SPACE to continue)";
			cText (txt);
			updateDisplay();
			key = getSingleKey();
	}
}

void awardExperience(int opponentNo)
{
	// x2 is default experience multiplier value for defeating an opponent in the Dungeon
	int experienceMultiplier = 2;

	if (opponentNo==GHOST)			experienceMultiplier = 8;
	if (opponentNo==DOPPLEGANGER)	experienceMultiplier = 7;
	if (opponentNo==MOLD)			experienceMultiplier = 3;

	int opponentXP = Opponents[0].maxHP*experienceMultiplier;
	increaseExperience(opponentXP);
}

void text(string str)
{
	bool keynotpressed = true;
	while ( keynotpressed )
	{
		drawEncounterView();
		cyText(4, str);
		updateDisplay();
		key = getSingleKey();
		if (key!="") { keynotpressed = false; }
	}
}


void checkFixedEncounters()
{
	switch(plyr.special)
    {
		case 1001: // troll tyrant & gang of 8 trolls
			//plyr.fixedEncounter = true;
			if ((plyr.trollsDefeated == false) && (plyr.trollsCombat)) { plyr.trollsCombat = false; runEncounter(71,1); if ( plyr.trollsDefeated ) { runEncounter(7,8); } }
			if ((plyr.trollsDefeated) && (plyr.trollsCombat)) { plyr.trollsCombat = false; runEncounter(7,8); }
            break;
		case 1002: // goblin lord & gang of 8 trolls
			//plyr.fixedEncounter = true;
			if ((plyr.goblinsDefeated == false) && (plyr.goblinsCombat)) { plyr.goblinsCombat = false; runEncounter(70,1); if ( plyr.goblinsDefeated ) { runEncounter(6,8); } }
			if ((plyr.goblinsDefeated) && (plyr.goblinsCombat)) { plyr.goblinsCombat = false; runEncounter(6,8); }
            break;
	}

	if ((plyr.special>0x79) && (plyr.special<0xA0)) // Dungeon only just now
	{
		plyr.fixedEncounter = true;
		plyr.fixedEncounterRef = plyr.special-128;
		switch(plyr.special)
		{
			case 0x80: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(UNDEAD_KNIGHT,1); break;
			case 0x81: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(UNDEAD_KNIGHT,1); break;
			case 0x82: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(UNDEAD_KNIGHT,1); break;
			case 0x83: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(UNDEAD_KNIGHT,1); break;
			case 0x84: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(UNDEAD_KNIGHT,1); break;
			case 0x85: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(UNDEAD_KNIGHT,1); break;
			case 0x86: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(UNDEAD_KNIGHT,1); break;
			case 0x87: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(BASILISK,1); break;
			case 0x88: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(DOPPLEGANGER,1); break;
			case 0x89: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(LICH,1); break;
			case 0x8A: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(VALKYRIE,1); break;
			case 0x8B: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(GREAT_NAGA,1); break;
			case 0x8C: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(WRAITH,3); break;
			case 0x8D: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(FLAME_DEMON,4); break;
			case 0x8E: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(DWARF,7); break;
			case 0x8F: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(VAMPIRE,8); break;
			case 0x90: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(WHIRLWIND,1); break;
			case 0x91: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(SMALL_DRAGON,1); break;
			case 0x92: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(GIANT_WOLF,3); break;
			case 0x93: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(DOPPLEGANGER,1); break;
			case 0x94: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(37,8); break;
			case 0x95: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(HOMUNCULUS,8); break;
			case 0x96: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(SKELETON,8); break;
			case 0x97: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(PHOENIX,1); break;
			case 0x98: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(GHOST,1); break;
			case 0x99: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(FLAME_DEMON,4); break;
			case 0x9A: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(VALKYRIE,1); break;
			case 0x9B: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(HORNED_DEVIL,1); break;
			case 0x9C: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(VAMPIRE,1); break;
			case 0x9D: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(SMALL_DRAGON,1); break;
			case 0x9E: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(DOPPLEGANGER,8); break;
			case 0x9F: if (plyr.fixedEncounters[plyr.fixedEncounterRef] == false) runEncounter(DEVOURER,1); break;

		}
	}

}


// Level 1 - Fixed Encounters
//51,4,88,
//54,5,95,
//60,5,98,
//58,7,96,
//41,19,8d,
//44,19,8c,
//47,19,8a,
//41,25,8e,
//44,25,8b,
//47,25,89,
//25,32,91,
//18,39,91,
//21,41,92,
//6,43,91,
//18,43,92,
//19,45,92,
//7,48,91,
//36,57,97,

// Level 2
//17,1,8f
//28,5,93
//28,12,93
//17,21,82
//19,21,81
//21,21,80
//17,23,83
//13,25,86
//15,25,85
//17,25,84

// Level 3
//11,7,99 4 flame demons
//10,8,9e
//12,8,9a
//10,9,9d
//11,9,9c
//12,10,9b
//14,13,87 basilisk


