#include <string>


enum damageImpacts
{
	INVULNERABLE = 0xF0,
	VULNERABLE = 0x0F
};

enum encounters
{
	DEVOURER = 0,
	THIEF = 1,
	CUTTHROAT = 2,
	BRIGAND = 3,
	MASTER_THIEF = 4,
	ASSASSIN = 5,
	GOBLIN = 6,
	TROLL = 7,
	LICH = 8,
	UNDEAD_KNIGHT = 9,
	GUARD = 10,
	FBI_AGENT = 11,
	DARK_KNIGHT = 12,
	CHAMPION = 13,
	HEALER = 14,
	KNIGHT = 15,
	PAUPER = 16,
	NOBLEMAN = 17,
	ALIEN_SENTRY = 18,
	ROBOT = 19,
	NOVICE = 20,
	APPRENTICE = 21,
	MAGE = 22,
	WIZARD = 23,
	ACOLYTE = 24,
	SAGE = 25,
	ORC = 26,
	GNOME = 27,
	DWARF = 28,
	SLIME = 29,
	MOLD = 30,
	HOMUNCULUS = 31,
	PHOENIX = 32,
	SORCERESS = 33,
	WHIRLWIND = 34,
	GIANT_RAT = 35,
	SMALL_DRAGON = 36,
	SKELETON = 37,
	ZOMBIE = 38,
	GHOUL = 39,
	GHOST = 40,
	SPECTRE = 41,
	WRAITH = 42,
	VAMPIRE = 43,
	GREAT_BAT = 44,
	HELLHOUND = 45,
	HARPY = 46,
	GREMLIN = 47,
	IMP = 48,
	FLAME_DEMON = 49,
	STORM_DEVIL = 50,
	GIANT_WOLF = 51,
	WEREWOLF = 52,
	WARRIOR = 53,
	WEAPONMASTER = 54,
	VALKYRIE = 55,
	GLADIATOR = 56,
	MERCENARY = 57,
	DOPPLEGANGER = 58,
	ADVENTURER = 59,
	WATERSPRITE = 60,
	NIGHTSTALKER = 61,
	SALAMANDER = 62,
	RONIN = 63,
	SERPENTMAN = 64,
	BIG_SNAKE = 65,
	GREAT_NAGA = 66,
	BERSERKER = 67,
	BASILISK = 68,
	GREAT_WYRM = 69,
	GOBLIN_LORD = 70,
	TROLL_TYRANT = 71,
	ICE_DEMON = 72,
	HORNED_DEVIL = 73,
	MUGGER = 74, // City only from here
	ROBBER = 75,
	FIGHTER = 76,
	SWORDSMAN = 77,
	COURIER = 78,
	COMMONER = 79,
	MERCHANT = 80,
	ARCHMAGE = 81,
	GNOLL = 82,
	HOBBIT = 83,
	GIANT = 84,
	SMALL_GREEN_DRAGON = 85,
	NOBLEWOMAN = 86

};


void checkFixedEncounters();
void opponentLeaves();
void updateOpponents();
void runEncounter(int monsterNo, int monsterQuantity);
void chooseEncounter();
//void SetTileImage(int tile_no);
//void loadCityMonsters();
void loadWeapons();
void loadEncounters();
//void convertDungeonMonsters();
void checkTreasure();
void checkTreasureWeapon();
void thiefYield();

int inputNumber();
void healerHealWounds();
void healerCureDiseases();
void healerCurePoisons();

void drawEncounterView();
void updateEncounterStatusText();
void initMonster(int monsterNo);
void playerAttack(int attackType,float attackFactorBonus);
//void displayMonsterDiag();
void opponentAttack();
void opponentDeath();
void playerCharm();
void playerTrick();
void playerTransact();
void playerHail();
void playerOffer();
void playerSwitchWeapons();
int opponentChooseWeapon();
int calculateWeaponDamage(int weaponNo, float attackFactor, int attacker);

void pauseEncounter();

struct encRecord
{
	int encProb;
	int encType;
	int encQuantity;
};


double round(double d);

struct monster
{
	std::string name;
	std::string pluName;
	std::string armorText;
	int behaviour; // evil, bad, neutral, good
	int alignment;
	int stealth;
	int randomStrength;
	int randomSkill;
	int randomIntelligence;
	int randomSpeed;
	int hp;
	int randomHP;
	int maxHP;
	int image;
	int image2;

	int sta;
	int	cha;
	int	str;
	int	inte;
	int	wis;
	int	skl;
	int	spd;

	int aBlunt;
	int aSharp;
	int aEarth;
	int aAir;
	int aFire;
	int aWater;
	int aPower;
	int aMagic;
	int aGood;
	int aEvil;
	int aCold;

	int tPotions;
	int tEquipment;
	int tFood;
	int tWater;
	int tTorches;
	int tTimepieces;
	int tCompasses;
	int tKeys;
	int tCrystals;
	int tCopper;
	int tSilver;
	int tGold;
	int tGems;
	int tJewels;

	int w1;
	int w2;
	int w3;
	int w4;
	int w5;
	int w6;
	int c1;
	int c2;
	int c3;
	int c4;
	int c5;
	int c6;
};


struct weapon
{
	std::string article;
	std::string name;
	std::string desc;
	std::string descMon;
	int type;
	int parry;
	int bonusToHit;
	int minStrength;
	int minDexterity;
	int useStrength;
	int blunt;
	int sharp;
	int earth;
	int air;
	int fire;
	int water;
	int power;
	int magic; // mental
	int good; // cleric
	int evil;
	int cold;
	int weight;
	int maxHP;
	int minAlignment;
	int twoHanded;
	int ammo;
};



