#include <string>

struct clothingItem
{
	// Description is created from values below if name blank
	// Clothing items have no body location
	// 4 items can be worn at same time
	string name;
	int quality;
	int colour;
	int fabric;
	int type;
	int weight;
};

struct armorItem
{
       string name;
	   int weight;
	   int bodyLocation;
       int blunt;
	   int sharp;
};

struct potionItem
{
       string name;
	   string color;
       string taste;
	   string sip;
};

struct questItem
{
       string name;
	   int weight;
};

string getItemDesc(int itemRef);
void moveItem(int itemRef,int newLocation);

void cannotCarryMessage();
void displayLocation();
void castSpellMessage(string spellDesc);
void spellBackfiredMessage(int spellPoints);
void castSpells();
void attemptSpell(int spellRef);
int createQuestItem(int questItemNo);
int createWeapon(int weapon_no);
int createClothing(int clothing_no);
void swapClothing(int object_ref);
int createGenericItem(int type, int value);
bool checkForQuestItem(int itemNo);
int getQuestItemRef(int itemNo);
void getItems();
int selectItem(int selectMode);
void determineItemAction(int selectItemMode, int itemRef);
int inputItemQuantity(int selectItemMode);
void dropVolumeObject(int selectItemMode, int object_ref);
void checkForItemsHere();
int checkForGenericItemsHere(int type);
void use_food();
void use_water();
void use_torch();
void use_timepiece();
void use_potion(int object_ref);
void quaffPotion(int object_ref);
void use_weapon(int object_ref);
void use_clothing(int object_ref);
int createArmor(int armor_no);
int createPotion(int potion_no);
void useObject(int object_ref);
void dropObject(int object_ref);

void itemMessage(string message);
//void depositObject(int object_ref);

void depositObject(int itemRef);
void withdrawalObject(int itemRef);
int inputDepositQuantity(int itemRef);
int inputWithdrawalQuantity(int itemRef);

void use_armor(int object_ref);
void use_questItem(int object_ref);

void displayObjectBuffer();

void tidyObjectBuffer();

int returnCarriedWeight();
