#include <SFML/Graphics.hpp>

#include <string>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fstream>
#include <iostream>
#include <sstream>

#include "globals.h"
#include "dev.h"

#include "createCharacter.h"
#include "player.h"
#include "misc.h"
#include "display.h"
#include "font.h"
#include "smithy.h"
#include "bank.h"
#include "tavern.h"
#include "shop.h"
#include "items.h"
#include "automap.h"

using namespace std;

// NOTES:
// job openings not currently part of saved game

Player plyr;

buffer_item itemBuffer[100]; // Items on floor and carried and in void
spellItem spellBuffer[35]; // learnt spells that can be cast
effectItem effectBuffer[50]; // active time limited effects from spells, scrolls, eyes

bool autoMapExplored[5][4096]; // 5 levels of 4096 on/off values

int shopDailyWares[15][12]; //15 shops with 12 items each a day for sale
int smithyDailyWares[4][10]; // 4 smithies with 10 items each a day for sale
int tavernDailyFoods[14][6]; // 14 taverns with 6 food items each day for sale
int tavernDailyDrinks[14][6]; // 14 taverns with 6 drink items each day for sale

int character[24576];
string saveGameDescriptions[10];

void displayLoadGame()
{
	string str;
	//SetFontColour(40, 96, 244, 255);
	drawText (1,3,"(0)");
	drawText (1,5,"(1)");
	drawText (1,7,"(2)");
	drawText (1,9,"(3)");
	drawText (1,11,"(4)");
	drawText (1,13,"(5)");
	drawText (1,15,"(6)");
	drawText (1,17,"(7)");
	drawText (1,19,"(8)");
	drawText (1,21,"(9)");

	drawText(8,23,"Select 0-9 or ESC to cancel");

	//SetFontColour(215, 215, 215, 255);

	for (int a = 0; a < 10; ++a) // number of save game slots 0 - 9
	{
        str	= saveGameDescriptions[a];
        drawText(5,((a*2)+3),str);
	}

}

void initSaveGameDescriptions()
{
	std::ifstream instream;
	//std::string junk,junk2, data;

	instream.open("data/saves/saveGames.txt");
	string text;

	//getline(instream, text); // read first line from the file for the character name
	//plyr.name = text;
	for (int a = 0; a < 10; a++) // number of save game slots 0 - 9
	{
		getline(instream, text);
		saveGameDescriptions[a] = text;
	}
	instream.close();
}

void updateSaveGameDescriptions()
{
	ofstream outdata; // outdata is like cin
	//saveGameDescriptions[savegameMenu] = plyr.name;
	outdata.open("data/saves/saveGames.txt"); // opens the file

	for(int y = 0; y < 10; ++y)
	{
		outdata << saveGameDescriptions[y] << endl;
	}
	outdata.close();
}

void initcharacter()
{
	for (int i=0 ; i<24576 ; i++)
	{
		character[i] = 0;
	}
}


void saveCharacter()
{
	string key;
	plyr.status = 0;
	{
			int savegameMenu = 255; // high level menu



			while (savegameMenu < 256)
			{
				while (savegameMenu == 255) // main menu
				{
					clearDisplay();
					displayLoadGame();
					drawText(12,0,"Save a character");
					updateDisplay();

					key = getSingleKey();
					if ( key=="0" ) { savegameMenu = 0;  }
					if ( key=="1" ) { savegameMenu = 1; }
					if ( key=="2" ) { savegameMenu = 2; }
					if ( key=="3" ) { savegameMenu = 3; }
					if ( key=="4" ) { savegameMenu = 4; }
					if ( key=="5" ) { savegameMenu = 5; }
					if ( key=="6" ) { savegameMenu = 6; }
					if ( key=="7" ) { savegameMenu = 7; }
					if ( key=="8" ) { savegameMenu = 8; }
					if ( key=="9" ) { savegameMenu = 9; }
					if ( key=="ESC" ) { savegameMenu = 256; plyr.status=1; }
				}
				while (savegameMenu < 10) // attempt to save a character
				{
					ofstream outdata; // outdata is like cin
					saveGameDescriptions[savegameMenu] = plyr.name;
					updateSaveGameDescriptions();

					// Copy character object data (except name) into the character[4096] int block
					character[0] = plyr.gender;
					character[1] = plyr.hp;
					character[2] = plyr.maxhp;

					character[3] = plyr.scenario;
					character[4] = plyr.map;
					character[5] = plyr.mapWidth;
					character[6] = plyr.mapHeight;
					character[7] = plyr.x;
					character[8] = plyr.oldx;
					character[9] = plyr.y;
					character[10] = plyr.oldy;
					character[11] = plyr.facing;
					character[12] = plyr.front;
					character[13] = plyr.back;
					character[14] = plyr.left;
					character[15] = plyr.right;
					character[16] = plyr.frontheight;
					character[17] = plyr.leftheight;
					character[18] = plyr.rightheight;
					character[19] = plyr.floorTexture;
					character[20] = plyr.ceiling;
					character[21] = plyr.location;
					character[22] = plyr.special;
					character[23] = plyr.alive;
					character[24] = plyr.teleporting;
					character[25] = plyr.buffer_index;
					character[26] = plyr.infoPanel;
					character[27] = plyr.priWeapon;
					character[28] = plyr.secWeapon;
					character[29] = plyr.headArmour;
					character[30] = plyr.bodyArmour;
					character[31] = plyr.legsArmour;
					character[32] = plyr.armsArmour;
					character[33] = plyr.timeOfDay;
					character[34] = plyr.minutes;
					character[35] = plyr.hours;
					character[36] = plyr.days;
					character[37] = plyr.months;
					character[38] = plyr.years;

					character[39] = plyr.sta;
					  character[40] = plyr.chr;
					  character[41] = plyr.str ;
					  character[42] = plyr.inte;
					  character[43] = plyr.wis;
					  character[44] = plyr.skl;
					  character[45] = plyr.maxhp;
					  character[46] = plyr.hp;
					  character[47] = plyr.xp;
					  character[48] = plyr.level; // xp level
					  character[49] = plyr.chrPartials;
					  character[50] = plyr.intPartials;
					  character[51] = plyr.strPartials;
					  character[52] = plyr.speed;
					 character[53] = plyr.stealth;
					  character[54] = plyr.diagOn;
					  character[55] = plyr.mapOn;
					 character[56] = plyr.fpsOn ;
					  character[57] = plyr.miniMapOn;
					  character[58] = plyr.silver;
					  character[59] = plyr.gold;
					  character[60] = plyr.copper;
					  character[61] = plyr.food;
					  character[62] = plyr.torches;
					  character[63] = plyr.water;
					  character[64] = plyr.timepieces;
					  character[65] = plyr.crystals;
					  character[66] = plyr.jewels;
					 character[67] = plyr.gems ;
					 character[68] = plyr.compasses ;
					  character[69] =plyr.keys;

					  character[70] = plyr.encounter_done;
					  character[71] = plyr.game_on;
					  character[72] = plyr.gender;

					  character[73] = plyr.zone;
					  character[74] = plyr.zoneSet;
					  character[75] = plyr.current_zone; // used by drawing function
					  character[76] = plyr.status;
					  character[77] = plyr.specialwall;
//					  character[78] = plyr.windowSize;
//					  character[79] = plyr.graphicStyle;
					  character[80] = plyr.fixedEncounter;
					  character[81] = plyr.fixedEncounterRef;
					  character[82] = plyr.thirst;
					  character[83] = plyr.hunger;
					 character[84] = plyr.digestion ;
					  character[85] = plyr.alcohol;

					for(int y = 0; y < 12; ++y) { character[86+y] = plyr.guildAwards[y]; }
					for(int y = 0; y < 32; ++y) { character[98+y] = plyr.fixedEncounters[y]; }
					for(int y = 0; y < 14; ++y) { character[130+y] = plyr.guildMemberships[y]; }

					  character[144] = plyr.ringCharges;
					  character[145] = plyr.alignment;
					  character[146]=plyr.lfood;
					  character[147]=plyr.lwater;
					  character[148]=plyr.ltorches;
					  character[149]=plyr.ltimepieces;
					  character[150]=plyr.lcompasses;
					  character[151]=plyr.lkeys;
					  character[152]=plyr.lcrystals;
					  character[153]=plyr.lgems;
					  character[154]=plyr.ljewels;
					  character[155]=plyr.lgold;
					  character[156]=plyr.lsilver;
					  character[157]=plyr.lcopper;
					  character[158]=plyr.spellIndex;
					  character[159]=plyr.effectIndex;
					  character[160]=plyr.retreatFriendship;
					  character[161]=plyr.damonFriendship;

					  character[162]=plyr.smithyFriendships[0];
					  character[163]=plyr.smithyFriendships[1];
					  character[164]=plyr.smithyFriendships[2];
					  character[165]=plyr.smithyFriendships[3];

						character[166]=plyr.bankAccountStatuses[0];
						character[167]=plyr.bankAccountStatuses[1];
						character[168]=plyr.bankAccountStatuses[2];
						character[169]=plyr.bankAccountStatuses[3];
						character[170]=plyr.bankAccountStatuses[4];
						character[171]=plyr.bankAccountStatuses[5];
						character[172]=plyr.bankAccountStatuses[6];
						character[173]=plyr.bankAccountStatuses[7];
						character[174]=plyr.bankAccountStatuses[8];

						character[175]=plyr.bankAccountBalances[0];
						character[176]=plyr.bankAccountBalances[1];
						character[177]=plyr.bankAccountBalances[2];
						character[178]=plyr.bankAccountBalances[3];
						character[179]=plyr.bankAccountBalances[4];
						character[180]=plyr.bankAccountBalances[5];
						character[181]=plyr.bankAccountBalances[6];
						character[182]=plyr.bankAccountBalances[7];
						character[183]=plyr.bankAccountBalances[8];

						character[184] = plyr.clothing[0];
						character[185] = plyr.clothing[1];
						character[186] = plyr.clothing[2];
						character[187] = plyr.clothing[3];

                        character[188] = plyr.goblinsVisited;
                        character[189] = plyr.goblinsChallenged;
                        character[190] = plyr.goblinsDefeated;
                        character[191] = plyr.goblinsCombat;
                        character[192] = plyr.goblinsReforged;
                        character[193] = plyr.trollsVisited;
                        character[194] = plyr.trollsChallenged;
                        character[195] = plyr.trollsDefeated;
                        character[196] = plyr.trollsCombat;
                        character[197] = plyr.trollsReforged;

                        character[198] =  plyr.oracleReturnTomorrow;
                        character[199] =  plyr.oracleDay;
                        character[200] =  plyr.oracleMonth;
                        character[201] =  plyr.oracleYear;
                        character[202] =  plyr.oracleQuestNo;
                        character[203] =  plyr.healerDays[0];
                        character[204] =  plyr.healerDays[1];
                        character[205] =  plyr.healerHours[0];
                        character[206] =  plyr.healerHours[1];
                        character[207] =  plyr.healerMinutes[0];
                        character[208] =  plyr.healerMinutes[1];
                        character[209] =  plyr.treasureFinding;
                        character[210] =  plyr.invisibility;
                        character[211] = plyr.diseases[0];
                        character[212] = plyr.diseases[1];
                        character[213] = plyr.diseases[2];
                        character[214] = plyr.diseases[3];
                        character[215] = plyr.poison[0];
                        character[216] = plyr.poison[1];
                        character[217] = plyr.poison[2];
                        character[218] = plyr.poison[3];
                        character[219] = plyr.delusion;
                        for(int y = 0; y < 9; ++y) { character[220+y] = plyr.invulnerability[y]; }
                        character[229] = plyr.noticeability;
                        character[230] = plyr.protection1;
                        character[231] = plyr.protection2;

					// Copy item buffer
					int saveGameIndex = 400; // start location for object buffer items
					for(int z = 0; z < 100; ++z)
					{
						character[saveGameIndex] = itemBuffer[z].hp;
						character[saveGameIndex+1] = itemBuffer[z].index;
						character[saveGameIndex+2] = itemBuffer[z].level;
						character[saveGameIndex+3] = itemBuffer[z].location;
						character[saveGameIndex+4] = itemBuffer[z].type;
						character[saveGameIndex+5] = itemBuffer[z].x;
						character[saveGameIndex+6] = itemBuffer[z].y;
						saveGameIndex = saveGameIndex + 7;
					}



					// Copy spell buffer
					saveGameIndex = 1500; // start location for spell buffer items (70 bytes)
					for(int z = 0; z < 35; ++z)
					{
						character[saveGameIndex] = spellBuffer[z].no;
						character[saveGameIndex+1] = spellBuffer[z].percentage;
						saveGameIndex = saveGameIndex + 2;
					}

					// Copy effect buffer
					saveGameIndex = 1580; // start location for effect buffer items (200 bytes)
					for(int z = 0; z < 50; ++z)
					{
						character[saveGameIndex] = effectBuffer[z].effect;
						character[saveGameIndex+1] = effectBuffer[z].negativeValue;
						character[saveGameIndex+2] = effectBuffer[z].positiveValue;
						character[saveGameIndex+3] = effectBuffer[z].duration;
						saveGameIndex = saveGameIndex + 4;
					}

					// Smithy daily wares - int smithyDailyWares[4][10];
					saveGameIndex = 1200; // start location for object buffer items
					for(int z = 0; z < 4; ++z)
					{
						for(int x = 0; x < 10; ++x)
						{
							character[saveGameIndex] = smithyDailyWares[z][x];
							saveGameIndex++;
						}
					}

					//int tavernDailyFoods[14][6];
					saveGameIndex = 1250; // start location for object buffer items
					for(int z = 0; z < 14; ++z)
					{
						for(int x = 0; x < 6; ++x)
						{
							character[saveGameIndex] = tavernDailyFoods[z][x];
							saveGameIndex++;
						}
					}

					//int tavernDailyDrinks[14][6];
					saveGameIndex = 1350; // start location for object buffer items
					for(int z = 0; z < 14; ++z)
					{
						for(int x = 0; x < 6; ++x)
						{
							character[saveGameIndex] = tavernDailyDrinks[z][x];
							saveGameIndex++;
						}
					}

                    // int shopDailyWares[15][12];
                    saveGameIndex = 1450; // start location for object buffer items
					for(int z = 0; z < 15; ++z)
					{
						for(int x = 0; x < 12; ++x)
						{
							character[saveGameIndex] = shopDailyWares[z][x];
							saveGameIndex++;
						}
					}

					// Currently inn and tavern job openings are not part of saved game

					//bool autoMapExplored[5][4096];
					saveGameIndex = 4097; // start location for automapexplored
					for(int z = 0; z < 5; ++z)
					{
						for(int x = 0; x < 4096; ++x)
						{
							character[saveGameIndex] = autoMapExplored[z][x];
							saveGameIndex++;
						}
					}

					string filename = "data/saves/save"+itos(savegameMenu)+".txt";
					outdata.open(filename.c_str()); // opens the file
					if( !outdata )
					{
						cerr << "Error: character file could not be saved" << endl;
					}

					outdata << plyr.name << endl;
					outdata << plyr.z_offset << endl;
					//float z_offset;
					for(int y = 0; y < 24576; ++y)
					{
						outdata << character[y] << endl;
					}
					outdata.close();
					plyr.status=1; // for display canvas
					savegameMenu = 256;
				}
			}

		}

}


bool loadCharacter(int saveSlot)
{
	std::ifstream instream;
	std::string junk,junk2, data;

	string filename = "data/saves/save"+itos(saveSlot)+".txt";
	instream.open(filename.c_str()); // opens the file
	//instream.open("data/saves/save0.txt");
	if( !instream )
	{
		cerr << "No save game in this slot" << endl;
		return false;
	}
	string text;

	getline(instream, text); // read first line from the file for the character name
	plyr.name = text;
	getline(instream, text); // read second line from the file for the z_offset
	plyr.z_offset = atof(text.c_str());
	for (int a = 0; a < 24576; ++a) // number of attributes - test for 33
	{
		getline(instream, text);
		character[a] = atoi(text.c_str());
	}
	instream.close();

	// Copy character[24576] int block values back into the character object
	plyr.gender = character[0];
	plyr.hp = character[1];
	plyr.maxhp = character[2];

	plyr.scenario = character[3];
	plyr.map = character[4];
	plyr.mapWidth = character[5];
	plyr.mapHeight = character[6];
	plyr.x = character[7];
	plyr.oldx = character[8];
	plyr.y = character[9];
	plyr.oldy = character[10];
	plyr.facing = character[11];

	plyr.front = character[12];
	plyr.back = character[13];
	plyr.left = character[14];
	plyr.right = character[15];
	plyr.frontheight = character[16];
	plyr.leftheight = character[17];
	plyr.rightheight = character[18];
	plyr.floorTexture = character[19];
	plyr.ceiling = character[20];
	plyr.location = character[21];
	plyr.special = character[22];

	plyr.alive = character[23];

	plyr.teleporting = character[24];
	  plyr.buffer_index = character[25];
	  plyr.infoPanel = character[26];
	  plyr.priWeapon = character[27];
	  plyr.secWeapon = character[28];
	  plyr.headArmour = character[29];
	  plyr.bodyArmour = character[30];
	  plyr.legsArmour = character[31];
	  plyr.armsArmour = character[32];
	  plyr.timeOfDay = character[33];
	  plyr.minutes = character[34];
	  plyr.hours = character[35];
	  plyr.days = character[36];
	  plyr.months = character[37];
	  plyr.years = character[38];

	plyr.sta = character[39];
  plyr.chr = character[40];
  plyr.str = character[41];
  plyr.inte = character[42];
  plyr.wis = character[43];
  plyr.skl = character[44];
  plyr.maxhp = character[45];
  plyr.hp = character[46];
  plyr.xp = character[47];
  plyr.level = character[48]; // xp level
  plyr.chrPartials = character[49];
  plyr.intPartials = character[50];
  plyr.strPartials = character[51];
  plyr.speed = character[52];
  plyr.stealth = character[53];
  plyr.diagOn = character[54];
  plyr.mapOn = character[55];
  plyr.fpsOn = character[56];
  plyr.miniMapOn = character[57];
  plyr.silver = character[58];
  plyr.gold = character[59];
  plyr.copper = character[60];
  plyr.food = character[61];
  plyr.torches = character[62];
  plyr.water = character[63];
  plyr.timepieces = character[64];
  plyr.crystals = character[65];
  plyr.jewels = character[66];
  plyr.gems = character[67];
  plyr.compasses = character[68];
  plyr.keys = character[69];
  //string status_text = character[00];
  //plyr.alive = character[00];
  plyr.encounter_done = character[70];
  plyr.game_on = character[71];
  plyr.gender = character[72];
  //string name = character[00];
  //string message = character[00];
  //string weapon1 = character[00];
  //string weapon2 = character[00];
  plyr.zone = character[73];
  plyr.zoneSet = character[74];
  plyr.current_zone = character[75]; // used by drawing function
  plyr.status = character[76];
  plyr.specialwall = character[77];
//  plyr.windowSize = character[78];
  //plyr.graphicStyle = character[79];
  plyr.fixedEncounter = character[80];
  plyr.fixedEncounterRef = character[81];
  plyr.thirst = character[82];
  plyr.hunger = character[83];
  plyr.digestion = character[84];
  plyr.alcohol = character[85];

 for(int y = 0; y < 12; ++y) { plyr.guildAwards[y] = character[86+y]; }
 for(int y = 0; y < 32; ++y) { plyr.fixedEncounters[y] = character[98+y]; }
 for(int y = 0; y < 14; ++y) { plyr.guildMemberships[y] = character[130+y]; }

  plyr.ringCharges = character[144];
  plyr.alignment = character[145];
  plyr.lfood = character[146];
  plyr.lwater = character[147];
  plyr.ltorches = character[148];
  plyr.ltimepieces = character[149];
  plyr.lcompasses = character[150];
  plyr.lkeys = character[151];
  plyr.lcrystals = character[152];
  plyr.lgems = character[153];
  plyr.ljewels = character[154];
  plyr.lgold = character[155];
  plyr.lsilver = character[156];
  plyr.lcopper = character[157];
  plyr.spellIndex = character[158];
  plyr.effectIndex = character[159];
  plyr.retreatFriendship = character[160];
  plyr.damonFriendship = character[161];

  plyr.smithyFriendships[0] = character[162];
  plyr.smithyFriendships[1] =	character[163];
  plyr.smithyFriendships[2] =	character[164];
  plyr.smithyFriendships[3] =	character[165];

plyr.bankAccountStatuses[0] = character[166];
plyr.bankAccountStatuses[1] = character[167];
plyr.bankAccountStatuses[2] = character[168];
plyr.bankAccountStatuses[3] = character[169];
plyr.bankAccountStatuses[4] = character[170];
plyr.bankAccountStatuses[5] = character[171];
plyr.bankAccountStatuses[6] = character[172];
plyr.bankAccountStatuses[7] = character[173];
plyr.bankAccountStatuses[8] = character[174];

plyr.bankAccountBalances[0] = character[175];
plyr.bankAccountBalances[1] = character[176];
plyr.bankAccountBalances[2] = character[177];
plyr.bankAccountBalances[3] = character[178];
plyr.bankAccountBalances[4] = character[179];
plyr.bankAccountBalances[5] = character[180];
plyr.bankAccountBalances[6] = character[181];
plyr.bankAccountBalances[7] = character[182];
plyr.bankAccountBalances[8] = character[183];

plyr.clothing[0] = character[184];
plyr.clothing[1] = character[185];
plyr.clothing[2] = character[186];
plyr.clothing[3] = character[187];

plyr.goblinsVisited = character[188];
plyr.goblinsChallenged = character[189];
plyr.goblinsDefeated = character[190];
plyr.goblinsCombat = character[191];
plyr.goblinsReforged = character[192];
plyr.trollsVisited = character[193];
plyr.trollsChallenged = character[194];
plyr.trollsDefeated = character[195];
plyr.trollsCombat = character[196];
plyr.trollsReforged = character[197];

plyr.oracleReturnTomorrow = character[198];
plyr.oracleDay = character[199];
plyr.oracleMonth = character[200];
plyr.oracleYear = character[201];
plyr.oracleQuestNo = character[202];
plyr.healerDays[0] = character[203];
plyr.healerDays[1] = character[204];
plyr.healerHours[0] = character[205];
plyr.healerHours[1] = character[206];
plyr.healerMinutes[0] = character[207];
plyr.healerMinutes[1] = character[208];
plyr.treasureFinding = character[209];
plyr.invisibility = character[210];
plyr.diseases[0] = character[211];
plyr.diseases[1] = character[212];
plyr.diseases[2] = character[213];
plyr.diseases[3] = character[214];
plyr.poison[0] = character[215];

plyr.poison[1] = character[216];
plyr.poison[2] = character[217];
plyr.poison[3] = character[218];
plyr.delusion = character[219];
for(int y = 0; y < 9; ++y) { plyr.invulnerability[y] = character[220+y]; }
plyr.noticeability = character[229];
plyr.protection1 = character[230];
plyr.protection2 = character[231];

int loadGameIndex = 400; // start location for object buffer items
for(int z = 0; z < 100; ++z)
{
	itemBuffer[z].hp = character[loadGameIndex];
	itemBuffer[z].index = character[loadGameIndex+1];
	itemBuffer[z].level = character[loadGameIndex+2];
	itemBuffer[z].location = character[loadGameIndex+3];
	itemBuffer[z].type = character[loadGameIndex+4];
	itemBuffer[z].x = character[loadGameIndex+5];
	itemBuffer[z].y = character[loadGameIndex+6];
	loadGameIndex = loadGameIndex + 7;
}

// Copy spell buffer
loadGameIndex = 1500; // start location for spell buffer items (70 bytes)
for(int z = 0; z < 35; ++z)
{
	spellBuffer[z].no = character[loadGameIndex];
	spellBuffer[z].percentage = character[loadGameIndex+1];
	loadGameIndex = loadGameIndex + 2;
}

// Copy effect buffer
loadGameIndex = 1580; // start location for effect buffer items (200 bytes)
for(int z = 0; z < 50; ++z)
{
	effectBuffer[z].effect = character[loadGameIndex];
	effectBuffer[z].negativeValue = character[loadGameIndex+1];
	effectBuffer[z].positiveValue = character[loadGameIndex+2];
	effectBuffer[z].duration = character[loadGameIndex+3];
	loadGameIndex = loadGameIndex + 4;
}

// Smithy daily wares - int smithyDailyWares[4][10];
loadGameIndex = 1200;
for(int z = 0; z < 4; ++z)
{
	for(int x = 0; x < 10; ++x)
	{
		smithyDailyWares[z][x] = character[loadGameIndex];
		loadGameIndex++;
	}
}

//int tavernDailyFoods[14][6];
loadGameIndex = 1250;
for(int z = 0; z < 14; ++z)
{
	for(int x = 0; x < 6; ++x)
	{
		tavernDailyFoods[z][x] = character[loadGameIndex];
		loadGameIndex++;
	}
}

//int tavernDailyDrinks[14][6];
loadGameIndex = 1350;
for(int z = 0; z < 14; ++z)
{
	for(int x = 0; x < 6; ++x)
	{
		tavernDailyDrinks[z][x] = character[loadGameIndex];
		loadGameIndex++;
	}
}

// int shopDailyWares[15][12];
loadGameIndex = 1450;
for(int z = 0; z < 15; ++z)
{
	for(int x = 0; x < 12; ++x)
	{
		shopDailyWares[z][x] = character[loadGameIndex];
		loadGameIndex++;
	}
}

// Currently inn and tavern job openings are not part of saved game

// load automap flags
loadGameIndex = 4097; // start location for object buffer items
for(int z = 0; z < 5; ++z)
{
	for(int x = 0; x < 4096; ++x)
	{
		autoMapExplored[z][x] = character[loadGameIndex];
		loadGameIndex++;
	}
}

  return true;
}



void increaseExperience(int xpIncrease)
{
	double levelBottom, levelTop, basePower;
	basePower = 2;
	if (plyr.level==0) {levelBottom = 200; } else { levelBottom = 200 * pow(basePower,plyr.level); }
	levelTop = levelBottom*2;
	levelBottom--;
	plyr.xp+=xpIncrease;
	if ((plyr.xp > levelBottom) && (plyr.xp < levelTop)) increaseLevel();
}



void increaseLevel()
{
	int statBonuses[7];
	int statBonus;
	plyr.level++;
	for(int x = 0; x < 7; ++x) { statBonuses[x] = 0; }

	// Increase hit points
	int hpIncrease= randn(0,plyr.sta);
	plyr.hp+=hpIncrease;
	plyr.maxhp+=hpIncrease;

	// Increase stats
	for(int x = 0; x < 7; ++x)
	{
		statBonus = randn(1,100); // roll to see if this stat will receive a bonus
		if (statBonus > 30) { statBonuses[x] = randn(0,3); } // Award a stat bonus
	}

	// Add the bonuses (which might be 0)
	plyr.sta	+= statBonuses[0];
	plyr.chr	+= statBonuses[1];
	plyr.str	+= statBonuses[2];
	plyr.inte	+= statBonuses[3];
	plyr.wis	+= statBonuses[4];
	plyr.skl	+= statBonuses[5];
	plyr.speed	+= statBonuses[6];
}



void checkBackgroundTime()
{
	plyr.timeOfDay = 0;

	if ((plyr.hours > 18) || (plyr.hours < 4)) { plyr.timeOfDay = 1;} // 6pm to 3am dark hours
	if ((plyr.hours == 4) && (plyr.minutes>=0) && (plyr.minutes<30)) { plyr.timeOfDay = 1;} // 4am - 4:29 dark hours

	if ((plyr.hours==4) && (plyr.minutes>29) && (plyr.minutes<=59)) { plyr.timeOfDay = 2; }
	if ((plyr.hours==5) && (plyr.minutes<=29)) { plyr.timeOfDay = 3; }
	if ((plyr.hours==5) && (plyr.minutes>29) && (plyr.minutes<=59)) { plyr.timeOfDay = 4; }
	if ((plyr.hours==6) && (plyr.minutes<=29)) { plyr.timeOfDay = 5; }
	if ((plyr.hours==6) && (plyr.minutes>29) && (plyr.minutes<=59)) { plyr.timeOfDay = 6; }
	if ((plyr.hours==7) && (plyr.minutes<=29)) { plyr.timeOfDay = 7; }

	if ((plyr.hours==16) && (plyr.minutes<=29)) { plyr.timeOfDay = 7; }
	if ((plyr.hours==16) && (plyr.minutes>29) && (plyr.minutes<=59)) { plyr.timeOfDay = 6; }
	if ((plyr.hours==17) && (plyr.minutes<=29)) { plyr.timeOfDay = 5; }
	if ((plyr.hours==17) && (plyr.minutes>29) && (plyr.minutes<=59)) { plyr.timeOfDay = 4; }
	if ((plyr.hours==18) && (plyr.minutes<=29)) { plyr.timeOfDay = 3; }
	if ((plyr.hours==18) && (plyr.minutes>29) && (plyr.minutes<=59)) { plyr.timeOfDay = 2; }

	//if ((plyr.hours == 17) || (plyr.hours == 5)) { plyr.timeOfDay = 2;}
}


void addMinute()
{
	if (plyr.minutes==59)
	{
		plyr.minutes=0;
		addHour();
	}
	else
	{
		plyr.minutes++;
	}
	// perform minute actions - disease, hp point loss, check for weather change etc
	checkBackgroundTime();
}

void addHour()
{
	if (plyr.hours == 23)
	{
		plyr.hours = 0; // 12 midnight important for Ferry crossing
		plyr.hunger += 2;
		plyr.thirst += 2;
		if (plyr.alcohol > 0) { plyr.alcohol--; }
		addDay();
	}
	else
	{
		plyr.hours++;
		// perform hourly actions / checks
		plyr.hunger += 2;
		plyr.thirst += 2;
		if (plyr.alcohol > 0) { plyr.alcohol--; }
	}
	checkActiveMagic();
	updateDisease();
	updatePoison();
	checkBackgroundTime();

}


void addDay()
{
	if (plyr.days == 31)
	{
		plyr.days = 1; // first day of a new month
		addMonth();
	}
	else
	{
		plyr.days++;
		// perform daily actions / checks / shop changes
		stockSmithyWares();
		stockShopWares();
		stockTavernDrinks();
		stockTavernFoods();
		checkDailybankInterest();
	}
}


void addMonth()
{
	if (plyr.months == 12)
	{
		plyr.months = 1; // first month of a new year
		addYear();
	}
	else
	{
		plyr.months++;
		// perform monthly actions - are there any? Weather changes?
	}
}


void addYear()
{
	plyr.years++;
	// perform yearly actions - bank interest?
}





std::string itos(int i)	// convert int to string
{
	std::stringstream s;
	s << i;
	return s.str();
}

std::string ftos(float i)	// convert float to string
{
	std::stringstream s;
	s << i;
	return s.str();
}

string checkThirst()
{
	string thirstDesc;
	thirstDesc = ""; // alcohol level is 0
	if ((plyr.thirst > 16) && (plyr.thirst < 33)) { thirstDesc = "Thirsty"; }
	if ((plyr.thirst > 32) && (plyr.thirst < 57)) { thirstDesc = "Very Thirsty"; }
	if (plyr.thirst > 56 ) { thirstDesc = "Parched"; }
	return thirstDesc;
}


string checkHunger()
{
	string hungerDesc;
	hungerDesc = ""; // alcohol level is 0
	if ((plyr.hunger > 16) && (plyr.hunger < 49)) { hungerDesc = "Hungry"; }
	if ((plyr.hunger > 48) && (plyr.hunger < 97)) { hungerDesc = "Famished"; }
	if (plyr.hunger > 96 ) { hungerDesc = "Starving"; }
	return hungerDesc;
}

string checkAlcohol()
{
	string alcoholDesc;
	alcoholDesc = ""; // alcohol level is 0
	if ((plyr.alcohol > 0) && (plyr.alcohol < plyr.sta)) { alcoholDesc = "Tipsy"; }
	if ((plyr.alcohol >= plyr.sta) && (plyr.alcohol < (plyr.sta*2))) { alcoholDesc = "Drunk"; }
	if (plyr.alcohol >= (plyr.sta*2)) { alcoholDesc = "Very Drunk"; }
	return alcoholDesc;
}


string checkEncumbrance()
{
	string weightDesc ="";
	int weight = returnCarriedWeight();
	int encumbrance = weight - (plyr.str + 224);
	if ((encumbrance >= 0) && (encumbrance < 16)) { weightDesc = "Burdened"; }
	if ((encumbrance >= 16) && (encumbrance < 33)) { weightDesc = "Encumbered"; }
	if (encumbrance >= 33) { weightDesc = "Immobilized!"; }
	return weightDesc;
}

string checkPoison()
{
    string poisonDesc ="";
    if ((plyr.poison[0]>0) || (plyr.poison[0]>0) || (plyr.poison[0]>0) || (plyr.poison[0]>0))  { poisonDesc = "Poisoned!"; }
    return poisonDesc;
}
string checkDisease()
{
    string diseaseDesc ="";
    if ((plyr.diseases[0]>0) || (plyr.diseases[0]>0) || (plyr.diseases[0]>0) || (plyr.diseases[0]>0))  { diseaseDesc = "Diseased!"; }
    return diseaseDesc;
}

void updateDisease()
{
    int rabiesStatus = plyr.diseases[0];
    if (rabiesStatus > 0)
    {
        // 0 - no rabies, 1-14 in incubation, 15 - active and identified
        if (rabiesStatus<15) { plyr.diseases[0]++; }
        else
        {
            plyr.hp -= 5; // temporary penalty.
        }
    }
}

void updatePoison()
{
    if (plyr.poison[0] > 0) { plyr.hp -= 2; }
    if (plyr.poison[1] > 0) { plyr.hp -= 5; }
    if (plyr.poison[2] > 0) { plyr.hp -= 7; }
    if (plyr.poison[3] > 0) { plyr.hp -= 10; }
}

void checkActiveMagic()
{
        if (plyr.protection1 > 0) { plyr.protection1--; }
        if (plyr.protection2 > 0) { plyr.protection2--; }
        if (plyr.invulnerability[0] > 0) { plyr.invulnerability[0]--; }
        if (plyr.invulnerability[1] > 0) { plyr.invulnerability[1]--; }
        if (plyr.invulnerability[2] > 0) { plyr.invulnerability[2]--; }
        if (plyr.invulnerability[3] > 0) { plyr.invulnerability[3]--; }
        if (plyr.invulnerability[4] > 0) { plyr.invulnerability[4]--; }
        if (plyr.invulnerability[5] > 0) { plyr.invulnerability[5]--; }
        if (plyr.invulnerability[6] > 0) { plyr.invulnerability[6]--; }
        if (plyr.invulnerability[7] > 0) { plyr.invulnerability[7]--; }
        if (plyr.invulnerability[8] > 0) { plyr.invulnerability[8]--; }
}

void initStats()
{
    for (int i=0 ; i<=14 ; i++) plyr.guildMemberships[i] = 0;
    for (int i=0 ; i<=11 ; i++) plyr.guildAwards[i] = false;
    for (int i=0 ; i<32 ; i++) plyr.fixedEncounters[i] = false;
    for (int i=0 ; i<9 ; i++) plyr.bankAccountStatuses[i] = 0;
    for (int i=0 ; i<9 ; i++) plyr.bankAccountBalances[i] = 0;
    for (int i=0 ; i<14 ; i++) plyr.tavernFriendships[i] = 2;
    for (int i=0 ; i<15 ; i++) plyr.shopFriendships[i] = 2;

    plyr.healerDays[0] = 0;
    plyr.healerHours[0] = 0;
    plyr.healerMinutes[0] = 0;
    plyr.healerDays[1] = 0;
    plyr.healerHours[1] = 0;
    plyr.healerMinutes[1] = 0;
    plyr.teleporting = 0; // counter that is used for flashing teleport sequence
    plyr.z_offset = 1.0f;
    plyr.scenario = 255; // city 0, dungeon 1 - 255 means main menu for font choice
    plyr.map = 0; // city
    plyr.x = 63; // 49
    plyr.y = 63; // 3
    plyr.facing = 2; // 2 equals north?
    plyr.sta = 24;
    plyr.chr = 25;
    plyr.str = 25;
    plyr.inte = 25;
    plyr.wis = 13;
    plyr.skl = 23;
    plyr.hp = 20;
    plyr.maxhp = 20;
    plyr.name = "Acrinimiril";
    plyr.xp = 0;
    plyr.level = 0;
    plyr.alive = true;
    plyr.encounter_done = true;
    plyr.gender = 0;
    plyr.zone = 1;
    plyr.status = 1; // Exploring
    plyr.torches = 3;
    plyr.food = 3;
    plyr.water = 3;
    plyr.timepieces = 0;
    plyr.compasses = 0;
    plyr.gems = 0;
    plyr.jewels = 0;
    plyr.crystals = 0;
    plyr.copper = 250;
    plyr.silver = 0;
    plyr.gold = 0;
    plyr.keys = 0;

    // Do not set these values manually - must be set by USE command in game! They hold array references within inventory
    plyr.priWeapon = 255; // bare hand
    plyr.secWeapon = 255; // bare hand
    plyr.headArmour = 255; // none
    plyr.bodyArmour = 255; // none
    plyr.legsArmour = 255; // none
    plyr.armsArmour = 255; // none

    plyr.infoPanel = 1;
    plyr.stealth = 32; //was 4
    plyr.speed = 10;
    plyr.diagOn = false;
    plyr.fpsOn = false;
    plyr.miniMapOn = false;

    plyr.chrPartials = 0;
    plyr.intPartials = 0;
    plyr.strPartials = 0;
    plyr.buffer_index = 0;
    plyr.zone = 0;
    plyr.zoneSet = 0;
    plyr.specialwall = 0;

    plyr.minutes = 0;
    plyr.hours = 8; // should be 12
    plyr.days = 30;
    plyr.months = 4;
    plyr.years = 0;
    plyr.timeOfDay=0;


    // Quest flags
    plyr.goblinsVisited = false;
    plyr.goblinsChallenged = false;
    plyr.trollsVisited = false;
    plyr.trollsChallenged = false;
    plyr.trollsDefeated = false;
    plyr.trollsCombat = false;
    plyr.goblinsDefeated = false;
    plyr.goblinsCombat = false;
    plyr.goblinsReforged = false;
    plyr.trollsReforged = false;

    plyr.thirst = 0;
    plyr.hunger = 0;
    plyr.digestion = 0;
    plyr.alcohol = 0;

    plyr.alignment = 128; // was 128
    plyr.buffer_index = 0;
    plyr.spellIndex = 0;

    plyr.retreatFriendship = 5;
    plyr.damonFriendship = 2;
    plyr.smithyFriendships[0] = 2;
    plyr.smithyFriendships[1] = 2;
    plyr.smithyFriendships[2] = 2;
    plyr.smithyFriendships[3] = 2;

    for (int i=0 ; i<=35 ; i++) { spellBuffer[i].no = 255; } // Set buffer to 255 to stop confusion about learning spell no. 0
    for (int i=0 ; i<=3 ; i++) { plyr.clothing[i] = 255; } // Not wearing any clothing
    for (int i=0 ; i<20 ; i++) { plyr.doorDetails[i].direction=0; plyr.doorDetails[i].x=0; plyr.doorDetails[i].y=0; plyr.doorDetails[i].level=0; } // Initialise door buffer
    plyr.doorDetailIndex=0;

    plyr.oracleReturnTomorrow = false;
    plyr.oracleDay = 255; // unset
    plyr.oracleMonth = 255;
    plyr.oracleYear = 255;
    plyr.oracleQuestNo = 0; // First quest from Oracle is silver key & palace prison

    plyr.treasureFinding = 5;
    plyr.invisibility = 0;
    plyr.diseases[0] = 0;
    plyr.diseases[1] = 0;
    plyr.diseases[2] = 0;
    plyr.diseases[3] = 0;
    plyr.poison[0] = 0;
    plyr.poison[1] = 0;
    plyr.poison[2] = 0;
    plyr.poison[3] = 0;
    plyr.delusion = 0;
    for (int i=0 ; i<9 ; i++) { plyr.invulnerability[i] = 0; }
    plyr.noticeability = 0;
    plyr.protection1 = 0;
    plyr.protection2 = 0;


    plyr.undeadKingVisited = false;

    plyr.special = 0;

    createClothing(0); // Put "Cheap Robe" into inventory
    plyr.clothing[0] = 0; // Point to first item in itemBuffer (Cheap Robe)
    plyr.clothing[1] = 255;
    plyr.clothing[2] = 255;
    plyr.clothing[3] = 255;

    plyr.mapWidth=64;
    plyr.mapHeight=64;

}

void createNewCharacter(int scenario)
{
	initStats();

	switch(scenario)
    {
        case CITY:
            plyr.x = 35;
            plyr.y = 36;
            plyr.scenario = CITY;
            plyr.map=0;
            plyr.facing = NORTH;
            break;
        case DUNGEON:
            plyr.scenario = DUNGEON;
            plyr.map=1;
            plyr.x = 49;
            plyr.y = 3;
            plyr.facing = WEST;
            break;
    }

    stockSmithyWares();
    stockTavernDrinks();
    stockTavernFoods();
    stockShopWares();

    if (AR_DEV.CHARACTER_CREATION==ON)
    {
        getPlayerName();
        switch(scenario)
        {
            case CITY:
                cityGate();
                break;
            case DUNGEON:
                dungeonGate();
                break;
        }

    }
}
